/* Media.c generated by valac 0.44.0, the Vala compiler
 * generated from Media.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Scott Ringwelski <sgringwe@mtu.edu>
 *              Victor Eduardo <victoreduardm@gmail.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define NOISE_TYPE_MEDIA (noise_media_get_type ())
#define NOISE_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_MEDIA, NoiseMedia))
#define NOISE_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_MEDIA, NoiseMediaClass))
#define NOISE_IS_MEDIA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_MEDIA))
#define NOISE_IS_MEDIA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_MEDIA))
#define NOISE_MEDIA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_MEDIA, NoiseMediaClass))

typedef struct _NoiseMedia NoiseMedia;
typedef struct _NoiseMediaClass NoiseMediaClass;
typedef struct _NoiseMediaPrivate NoiseMediaPrivate;

#define NOISE_TYPE_ALBUM (noise_album_get_type ())
#define NOISE_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), NOISE_TYPE_ALBUM, NoiseAlbum))
#define NOISE_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), NOISE_TYPE_ALBUM, NoiseAlbumClass))
#define NOISE_IS_ALBUM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NOISE_TYPE_ALBUM))
#define NOISE_IS_ALBUM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), NOISE_TYPE_ALBUM))
#define NOISE_ALBUM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), NOISE_TYPE_ALBUM, NoiseAlbumClass))

typedef struct _NoiseAlbum NoiseAlbum;
typedef struct _NoiseAlbumClass NoiseAlbumClass;
enum  {
	NOISE_MEDIA_0_PROPERTY,
	NOISE_MEDIA_ROWID_PROPERTY,
	NOISE_MEDIA_URI_PROPERTY,
	NOISE_MEDIA_FILE_SIZE_PROPERTY,
	NOISE_MEDIA_FILE_EXISTS_PROPERTY,
	NOISE_MEDIA_FILE_PROPERTY,
	NOISE_MEDIA_IS_PREVIEW_PROPERTY,
	NOISE_MEDIA_IS_TEMPORARY_PROPERTY,
	NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY,
	NOISE_MEDIA_HAS_EMBEDDED_PROPERTY,
	NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY,
	NOISE_MEDIA_SHOW_INDICATOR_PROPERTY,
	NOISE_MEDIA_TITLE_PROPERTY,
	NOISE_MEDIA_TRACK_PROPERTY,
	NOISE_MEDIA_TRACK_COUNT_PROPERTY,
	NOISE_MEDIA_COMPOSER_PROPERTY,
	NOISE_MEDIA_ARTIST_PROPERTY,
	NOISE_MEDIA_ALBUM_ARTIST_PROPERTY,
	NOISE_MEDIA_ALBUM_PROPERTY,
	NOISE_MEDIA_ALBUM_NUMBER_PROPERTY,
	NOISE_MEDIA_ALBUM_COUNT_PROPERTY,
	NOISE_MEDIA_ALBUM_INFO_PROPERTY,
	NOISE_MEDIA_GROUPING_PROPERTY,
	NOISE_MEDIA_GENRE_PROPERTY,
	NOISE_MEDIA_COMMENT_PROPERTY,
	NOISE_MEDIA_LYRICS_PROPERTY,
	NOISE_MEDIA_YEAR_PROPERTY,
	NOISE_MEDIA_BITRATE_PROPERTY,
	NOISE_MEDIA_BPM_PROPERTY,
	NOISE_MEDIA_SAMPLERATE_PROPERTY,
	NOISE_MEDIA_LENGTH_PROPERTY,
	NOISE_MEDIA_RATING_PROPERTY,
	NOISE_MEDIA_PLAY_COUNT_PROPERTY,
	NOISE_MEDIA_SKIP_COUNT_PROPERTY,
	NOISE_MEDIA_DATE_ADDED_PROPERTY,
	NOISE_MEDIA_LAST_PLAYED_PROPERTY,
	NOISE_MEDIA_LAST_MODIFIED_PROPERTY,
	NOISE_MEDIA_RESUME_POS_PROPERTY,
	NOISE_MEDIA_SHOW_PROPERTY,
	NOISE_MEDIA_NUM_PROPERTIES
};
static GParamSpec* noise_media_properties[NOISE_MEDIA_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _NoiseMedia {
	GObject parent_instance;
	NoiseMediaPrivate * priv;
	guint _rating;
};

struct _NoiseMediaClass {
	GObjectClass parent_class;
	gchar* (*get_uri) (NoiseMedia* self);
	void (*set_uri) (NoiseMedia* self, const gchar* value);
	guint64 (*get_file_size) (NoiseMedia* self);
	void (*set_file_size) (NoiseMedia* self, guint64 value);
	gboolean (*get_file_exists) (NoiseMedia* self);
	GFile* (*get_file) (NoiseMedia* self);
	void (*set_file) (NoiseMedia* self, GFile* value);
	gboolean (*get_isPreview) (NoiseMedia* self);
	void (*set_isPreview) (NoiseMedia* self, gboolean value);
	gboolean (*get_isTemporary) (NoiseMedia* self);
	void (*set_isTemporary) (NoiseMedia* self, gboolean value);
	gboolean (*get_location_unknown) (NoiseMedia* self);
	void (*set_location_unknown) (NoiseMedia* self, gboolean value);
	gboolean (*get_has_embedded) (NoiseMedia* self);
	void (*set_has_embedded) (NoiseMedia* self, gboolean value);
	GIcon* (*get_unique_status_image) (NoiseMedia* self);
	void (*set_unique_status_image) (NoiseMedia* self, GIcon* value);
	gboolean (*get_showIndicator) (NoiseMedia* self);
	void (*set_showIndicator) (NoiseMedia* self, gboolean value);
	const gchar* (*get_title) (NoiseMedia* self);
	void (*set_title) (NoiseMedia* self, const gchar* value);
	guint (*get_track) (NoiseMedia* self);
	void (*set_track) (NoiseMedia* self, guint value);
	guint (*get_track_count) (NoiseMedia* self);
	void (*set_track_count) (NoiseMedia* self, guint value);
	const gchar* (*get_composer) (NoiseMedia* self);
	void (*set_composer) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_artist) (NoiseMedia* self);
	void (*set_artist) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_album_artist) (NoiseMedia* self);
	void (*set_album_artist) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_album) (NoiseMedia* self);
	void (*set_album) (NoiseMedia* self, const gchar* value);
	guint (*get_album_number) (NoiseMedia* self);
	void (*set_album_number) (NoiseMedia* self, guint value);
	guint (*get_album_count) (NoiseMedia* self);
	void (*set_album_count) (NoiseMedia* self, guint value);
	NoiseAlbum* (*get_album_info) (NoiseMedia* self);
	void (*set_album_info) (NoiseMedia* self, NoiseAlbum* value);
	const gchar* (*get_grouping) (NoiseMedia* self);
	void (*set_grouping) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_genre) (NoiseMedia* self);
	void (*set_genre) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_comment) (NoiseMedia* self);
	void (*set_comment) (NoiseMedia* self, const gchar* value);
	const gchar* (*get_lyrics) (NoiseMedia* self);
	void (*set_lyrics) (NoiseMedia* self, const gchar* value);
	guint (*get_year) (NoiseMedia* self);
	void (*set_year) (NoiseMedia* self, guint value);
	guint (*get_bitrate) (NoiseMedia* self);
	void (*set_bitrate) (NoiseMedia* self, guint value);
	guint (*get_bpm) (NoiseMedia* self);
	void (*set_bpm) (NoiseMedia* self, guint value);
	guint (*get_samplerate) (NoiseMedia* self);
	void (*set_samplerate) (NoiseMedia* self, guint value);
	guint (*get_length) (NoiseMedia* self);
	void (*set_length) (NoiseMedia* self, guint value);
	guint (*get_rating) (NoiseMedia* self);
	void (*set_rating) (NoiseMedia* self, guint value);
	guint (*get_play_count) (NoiseMedia* self);
	void (*set_play_count) (NoiseMedia* self, guint value);
	guint (*get_skip_count) (NoiseMedia* self);
	void (*set_skip_count) (NoiseMedia* self, guint value);
	guint (*get_date_added) (NoiseMedia* self);
	void (*set_date_added) (NoiseMedia* self, guint value);
	guint (*get_last_played) (NoiseMedia* self);
	void (*set_last_played) (NoiseMedia* self, guint value);
	guint (*get_last_modified) (NoiseMedia* self);
	void (*set_last_modified) (NoiseMedia* self, guint value);
	gint (*get_resume_pos) (NoiseMedia* self);
	void (*set_resume_pos) (NoiseMedia* self, gint value);
	gboolean (*get_show) (NoiseMedia* self);
	void (*set_show) (NoiseMedia* self, gboolean value);
};

struct _NoiseMediaPrivate {
	gint64 _rowid;
	guint64 _file_size;
	GFile* _file;
	gboolean _isPreview;
	gboolean _isTemporary;
	gboolean _location_unknown;
	gboolean _has_embedded;
	GIcon* _unique_status_image;
	gboolean _showIndicator;
	gchar* _title;
	guint _track;
	guint _track_count;
	gchar* _composer;
	gchar* _artist;
	gchar* _album_artist;
	gchar* _album;
	guint _album_number;
	guint _album_count;
	NoiseAlbum* _album_info;
	gchar* _grouping;
	gchar* _genre;
	gchar* _comment;
	gchar* _lyrics;
	guint _year;
	guint _bitrate;
	guint _bpm;
	guint _samplerate;
	guint _length;
	guint _play_count;
	guint _skip_count;
	guint _date_added;
	guint _last_played;
	guint _last_modified;
	gint _resume_pos;
	gboolean _show;
};

static gint NoiseMedia_private_offset;
static gpointer noise_media_parent_class = NULL;
extern gchar* noise_media_UNKNOWN;
gchar* noise_media_UNKNOWN = NULL;

GType noise_media_get_type (void) G_GNUC_CONST;
GType noise_album_get_type (void) G_GNUC_CONST;
gchar* noise_media_get_display_filename (NoiseMedia* self);
GFile* noise_media_get_file (NoiseMedia* self);
gchar* noise_string_locale_to_utf8 (const gchar* string_locale);
gboolean noise_media_is_valid_string_field (const gchar* text);
gchar* noise_media_get_display_location (NoiseMedia* self);
gboolean noise_media_get_isTemporary (NoiseMedia* self);
gchar* noise_media_get_display_title (NoiseMedia* self);
const gchar* noise_media_get_title (NoiseMedia* self);
gchar* noise_media_get_display_composer (NoiseMedia* self);
gchar* noise_media_get_simple_display_text (const gchar* text);
const gchar* noise_media_get_composer (NoiseMedia* self);
gchar* noise_media_get_display_artist (NoiseMedia* self);
const gchar* noise_media_get_artist (NoiseMedia* self);
gchar* noise_media_get_display_album_artist (NoiseMedia* self,
                                             gboolean use_artist_fallback);
const gchar* noise_media_get_album_artist (NoiseMedia* self);
gchar* noise_media_get_display_album (NoiseMedia* self);
const gchar* noise_media_get_album (NoiseMedia* self);
gchar* noise_media_get_display_genre (NoiseMedia* self);
const gchar* noise_media_get_genre (NoiseMedia* self);
gboolean noise_string_is_empty (const gchar* text,
                                gboolean check_white_space);
guint noise_media_get_album_hashkey (NoiseMedia* self);
gchar* noise_media_get_title_markup (NoiseMedia* self);
NoiseMedia* noise_media_new (const gchar* uri);
NoiseMedia* noise_media_construct (GType object_type,
                                   const gchar* uri);
void noise_media_set_uri (NoiseMedia* self,
                          const gchar* value);
NoiseMedia* noise_media_new_from_file (GFile* file);
NoiseMedia* noise_media_construct_from_file (GType object_type,
                                             GFile* file);
void noise_media_set_file (NoiseMedia* self,
                           GFile* value);
NoiseMedia* noise_media_copy (NoiseMedia* self);
gchar* noise_media_get_uri (NoiseMedia* self);
guint64 noise_media_get_file_size (NoiseMedia* self);
void noise_media_set_file_size (NoiseMedia* self,
                                guint64 value);
guint noise_media_get_track (NoiseMedia* self);
void noise_media_set_track (NoiseMedia* self,
                            guint value);
guint noise_media_get_track_count (NoiseMedia* self);
void noise_media_set_track_count (NoiseMedia* self,
                                  guint value);
guint noise_media_get_album_number (NoiseMedia* self);
void noise_media_set_album_number (NoiseMedia* self,
                                   guint value);
guint noise_media_get_album_count (NoiseMedia* self);
void noise_media_set_album_count (NoiseMedia* self,
                                  guint value);
void noise_media_set_title (NoiseMedia* self,
                            const gchar* value);
void noise_media_set_artist (NoiseMedia* self,
                             const gchar* value);
void noise_media_set_composer (NoiseMedia* self,
                               const gchar* value);
void noise_media_set_album_artist (NoiseMedia* self,
                                   const gchar* value);
void noise_media_set_album (NoiseMedia* self,
                            const gchar* value);
void noise_media_set_genre (NoiseMedia* self,
                            const gchar* value);
const gchar* noise_media_get_grouping (NoiseMedia* self);
void noise_media_set_grouping (NoiseMedia* self,
                               const gchar* value);
const gchar* noise_media_get_comment (NoiseMedia* self);
void noise_media_set_comment (NoiseMedia* self,
                              const gchar* value);
guint noise_media_get_year (NoiseMedia* self);
void noise_media_set_year (NoiseMedia* self,
                           guint value);
guint noise_media_get_bitrate (NoiseMedia* self);
void noise_media_set_bitrate (NoiseMedia* self,
                              guint value);
guint noise_media_get_length (NoiseMedia* self);
void noise_media_set_length (NoiseMedia* self,
                             guint value);
guint noise_media_get_samplerate (NoiseMedia* self);
void noise_media_set_samplerate (NoiseMedia* self,
                                 guint value);
guint noise_media_get_bpm (NoiseMedia* self);
void noise_media_set_bpm (NoiseMedia* self,
                          guint value);
guint noise_media_get_rating (NoiseMedia* self);
void noise_media_set_rating (NoiseMedia* self,
                             guint value);
guint noise_media_get_play_count (NoiseMedia* self);
void noise_media_set_play_count (NoiseMedia* self,
                                 guint value);
guint noise_media_get_skip_count (NoiseMedia* self);
void noise_media_set_skip_count (NoiseMedia* self,
                                 guint value);
guint noise_media_get_date_added (NoiseMedia* self);
void noise_media_set_date_added (NoiseMedia* self,
                                 guint value);
guint noise_media_get_last_played (NoiseMedia* self);
void noise_media_set_last_played (NoiseMedia* self,
                                  guint value);
const gchar* noise_media_get_lyrics (NoiseMedia* self);
void noise_media_set_lyrics (NoiseMedia* self,
                             const gchar* value);
gboolean noise_media_get_isPreview (NoiseMedia* self);
void noise_media_set_isPreview (NoiseMedia* self,
                                gboolean value);
void noise_media_set_isTemporary (NoiseMedia* self,
                                  gboolean value);
guint noise_media_get_last_modified (NoiseMedia* self);
void noise_media_set_last_modified (NoiseMedia* self,
                                    guint value);
gboolean noise_media_get_show (NoiseMedia* self);
void noise_media_set_show (NoiseMedia* self,
                           gboolean value);
gboolean noise_media_get_showIndicator (NoiseMedia* self);
void noise_media_set_showIndicator (NoiseMedia* self,
                                    gboolean value);
GIcon* noise_media_get_unique_status_image (NoiseMedia* self);
void noise_media_set_unique_status_image (NoiseMedia* self,
                                          GIcon* value);
gboolean noise_media_get_location_unknown (NoiseMedia* self);
void noise_media_set_location_unknown (NoiseMedia* self,
                                       gboolean value);
gint64 noise_media_get_rowid (NoiseMedia* self);
void noise_media_set_rowid (NoiseMedia* self,
                            gint64 value);
gboolean noise_media_get_file_exists (NoiseMedia* self);
gboolean noise_media_get_has_embedded (NoiseMedia* self);
void noise_media_set_has_embedded (NoiseMedia* self,
                                   gboolean value);
NoiseAlbum* noise_media_get_album_info (NoiseMedia* self);
void noise_media_set_album_info (NoiseMedia* self,
                                 NoiseAlbum* value);
gint noise_media_get_resume_pos (NoiseMedia* self);
void noise_media_set_resume_pos (NoiseMedia* self,
                                 gint value);
static void noise_media_finalize (GObject * obj);
static void _vala_noise_media_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_noise_media_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
noise_media_get_instance_private (NoiseMedia* self)
{
	return G_STRUCT_MEMBER_P (self, NoiseMedia_private_offset);
}

inline gchar*
noise_media_get_display_filename (NoiseMedia* self)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GFile* _tmp1_;
	GFile* _tmp2_;
	gchar* _tmp3_;
	gchar* filename = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp11_;
#line 100 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 101 "../core/Media.vala"
	_tmp1_ = noise_media_get_file (self);
#line 101 "../core/Media.vala"
	_tmp2_ = _tmp1_;
#line 101 "../core/Media.vala"
	_tmp3_ = g_file_get_basename (_tmp2_);
#line 101 "../core/Media.vala"
	_tmp0_ = _tmp3_;
#line 101 "../core/Media.vala"
	if (_tmp0_ == NULL) {
#line 414 "Media.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 101 "../core/Media.vala"
		_tmp4_ = noise_media_UNKNOWN;
#line 101 "../core/Media.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 101 "../core/Media.vala"
		_g_free0 (_tmp0_);
#line 101 "../core/Media.vala"
		_tmp0_ = _tmp5_;
#line 425 "Media.c"
	}
#line 101 "../core/Media.vala"
	_tmp6_ = noise_string_locale_to_utf8 (_tmp0_);
#line 101 "../core/Media.vala"
	filename = _tmp6_;
#line 102 "../core/Media.vala"
	_tmp8_ = filename;
#line 102 "../core/Media.vala"
	if (noise_media_is_valid_string_field (_tmp8_)) {
#line 435 "Media.c"
		const gchar* _tmp9_;
#line 102 "../core/Media.vala"
		_tmp9_ = filename;
#line 102 "../core/Media.vala"
		_tmp7_ = _tmp9_;
#line 441 "Media.c"
	} else {
		const gchar* _tmp10_;
#line 102 "../core/Media.vala"
		_tmp10_ = noise_media_UNKNOWN;
#line 102 "../core/Media.vala"
		_tmp7_ = _tmp10_;
#line 448 "Media.c"
	}
#line 102 "../core/Media.vala"
	_tmp11_ = g_strdup (_tmp7_);
#line 102 "../core/Media.vala"
	result = _tmp11_;
#line 102 "../core/Media.vala"
	_g_free0 (filename);
#line 102 "../core/Media.vala"
	_g_free0 (_tmp0_);
#line 102 "../core/Media.vala"
	return result;
#line 460 "Media.c"
}

inline gchar*
noise_media_get_display_location (NoiseMedia* self)
{
	gchar* result = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gchar* filename = NULL;
	GFile* _tmp3_;
	GFile* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp17_;
	gchar* _tmp18_;
#line 105 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 106 "../core/Media.vala"
	_tmp0_ = noise_media_get_isTemporary (self);
#line 106 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 106 "../core/Media.vala"
	if (_tmp1_) {
#line 487 "Media.c"
		gchar* _tmp2_;
#line 107 "../core/Media.vala"
		_tmp2_ = g_strdup ("");
#line 107 "../core/Media.vala"
		result = _tmp2_;
#line 107 "../core/Media.vala"
		return result;
#line 495 "Media.c"
	}
#line 109 "../core/Media.vala"
	_tmp3_ = noise_media_get_file (self);
#line 109 "../core/Media.vala"
	_tmp4_ = _tmp3_;
#line 109 "../core/Media.vala"
	_tmp5_ = g_file_get_path (_tmp4_);
#line 109 "../core/Media.vala"
	_tmp6_ = _tmp5_;
#line 109 "../core/Media.vala"
	_tmp7_ = noise_string_locale_to_utf8 (_tmp6_);
#line 109 "../core/Media.vala"
	_tmp8_ = _tmp7_;
#line 109 "../core/Media.vala"
	_g_free0 (_tmp6_);
#line 109 "../core/Media.vala"
	filename = _tmp8_;
#line 111 "../core/Media.vala"
	_tmp9_ = filename;
#line 111 "../core/Media.vala"
	if (noise_media_is_valid_string_field (_tmp9_)) {
#line 517 "Media.c"
		GFile* _tmp10_;
		GFile* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 112 "../core/Media.vala"
		_tmp10_ = noise_media_get_file (self);
#line 112 "../core/Media.vala"
		_tmp11_ = _tmp10_;
#line 112 "../core/Media.vala"
		_tmp12_ = g_file_get_uri_scheme (_tmp11_);
#line 112 "../core/Media.vala"
		_tmp13_ = _tmp12_;
#line 112 "../core/Media.vala"
		_tmp14_ = filename;
#line 112 "../core/Media.vala"
		_tmp15_ = g_strdup_printf ("%s:/%s", _tmp13_, _tmp14_);
#line 112 "../core/Media.vala"
		_tmp16_ = _tmp15_;
#line 112 "../core/Media.vala"
		_g_free0 (_tmp13_);
#line 112 "../core/Media.vala"
		result = _tmp16_;
#line 112 "../core/Media.vala"
		_g_free0 (filename);
#line 112 "../core/Media.vala"
		return result;
#line 547 "Media.c"
	}
#line 114 "../core/Media.vala"
	_tmp17_ = noise_media_UNKNOWN;
#line 114 "../core/Media.vala"
	_tmp18_ = g_strdup (_tmp17_);
#line 114 "../core/Media.vala"
	result = _tmp18_;
#line 114 "../core/Media.vala"
	_g_free0 (filename);
#line 114 "../core/Media.vala"
	return result;
#line 559 "Media.c"
}

inline gchar*
noise_media_get_display_title (NoiseMedia* self)
{
	gchar* result = NULL;
	gchar* title = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
#line 117 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "../core/Media.vala"
	_tmp0_ = noise_media_get_title (self);
#line 118 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 118 "../core/Media.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 118 "../core/Media.vala"
	title = _tmp2_;
#line 119 "../core/Media.vala"
	_tmp4_ = title;
#line 119 "../core/Media.vala"
	if (noise_media_is_valid_string_field (_tmp4_)) {
#line 586 "Media.c"
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 119 "../core/Media.vala"
		_tmp5_ = title;
#line 119 "../core/Media.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 119 "../core/Media.vala"
		_g_free0 (_tmp3_);
#line 119 "../core/Media.vala"
		_tmp3_ = _tmp6_;
#line 597 "Media.c"
	} else {
		gchar* _tmp7_;
#line 119 "../core/Media.vala"
		_tmp7_ = noise_media_get_display_filename (self);
#line 119 "../core/Media.vala"
		_g_free0 (_tmp3_);
#line 119 "../core/Media.vala"
		_tmp3_ = _tmp7_;
#line 606 "Media.c"
	}
#line 119 "../core/Media.vala"
	result = _tmp3_;
#line 119 "../core/Media.vala"
	_g_free0 (title);
#line 119 "../core/Media.vala"
	return result;
#line 614 "Media.c"
}

inline gchar*
noise_media_get_display_composer (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 122 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "../core/Media.vala"
	_tmp0_ = noise_media_get_composer (self);
#line 123 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 123 "../core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 123 "../core/Media.vala"
	result = _tmp2_;
#line 123 "../core/Media.vala"
	return result;
#line 636 "Media.c"
}

inline gchar*
noise_media_get_display_artist (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 126 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../core/Media.vala"
	_tmp0_ = noise_media_get_artist (self);
#line 127 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 127 "../core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 127 "../core/Media.vala"
	result = _tmp2_;
#line 127 "../core/Media.vala"
	return result;
#line 658 "Media.c"
}

inline gchar*
noise_media_get_display_album_artist (NoiseMedia* self,
                                      gboolean use_artist_fallback)
{
	gchar* result = NULL;
	gchar* album_artist = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
#line 130 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 131 "../core/Media.vala"
	_tmp0_ = noise_media_get_album_artist (self);
#line 131 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 131 "../core/Media.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 131 "../core/Media.vala"
	album_artist = _tmp2_;
#line 133 "../core/Media.vala"
	_tmp3_ = album_artist;
#line 133 "../core/Media.vala"
	if (noise_media_is_valid_string_field (_tmp3_)) {
#line 134 "../core/Media.vala"
		result = album_artist;
#line 134 "../core/Media.vala"
		return result;
#line 691 "Media.c"
	}
#line 136 "../core/Media.vala"
	if (use_artist_fallback) {
#line 695 "Media.c"
		gchar* _tmp4_;
#line 137 "../core/Media.vala"
		_tmp4_ = noise_media_get_display_artist (self);
#line 137 "../core/Media.vala"
		result = _tmp4_;
#line 137 "../core/Media.vala"
		_g_free0 (album_artist);
#line 137 "../core/Media.vala"
		return result;
#line 705 "Media.c"
	}
#line 139 "../core/Media.vala"
	_tmp5_ = noise_media_UNKNOWN;
#line 139 "../core/Media.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 139 "../core/Media.vala"
	result = _tmp6_;
#line 139 "../core/Media.vala"
	_g_free0 (album_artist);
#line 139 "../core/Media.vala"
	return result;
#line 717 "Media.c"
}

inline gchar*
noise_media_get_display_album (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 142 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 143 "../core/Media.vala"
	_tmp0_ = noise_media_get_album (self);
#line 143 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 143 "../core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 143 "../core/Media.vala"
	result = _tmp2_;
#line 143 "../core/Media.vala"
	return result;
#line 739 "Media.c"
}

inline gchar*
noise_media_get_display_genre (NoiseMedia* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
#line 146 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 147 "../core/Media.vala"
	_tmp0_ = noise_media_get_genre (self);
#line 147 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 147 "../core/Media.vala"
	_tmp2_ = noise_media_get_simple_display_text (_tmp1_);
#line 147 "../core/Media.vala"
	result = _tmp2_;
#line 147 "../core/Media.vala"
	return result;
#line 761 "Media.c"
}

inline gboolean
noise_media_is_valid_string_field (const gchar* text)
{
	gboolean result = FALSE;
#line 151 "../core/Media.vala"
	result = !noise_string_is_empty (text, TRUE);
#line 151 "../core/Media.vala"
	return result;
#line 772 "Media.c"
}

guint
noise_media_get_album_hashkey (NoiseMedia* self)
{
	guint result = 0U;
	GString* builder = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GString* _tmp12_;
	const gchar* _tmp13_;
#line 154 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 155 "../core/Media.vala"
	_tmp0_ = g_string_new ("");
#line 155 "../core/Media.vala"
	builder = _tmp0_;
#line 156 "../core/Media.vala"
	_tmp1_ = builder;
#line 156 "../core/Media.vala"
	_tmp2_ = noise_media_get_album (self);
#line 156 "../core/Media.vala"
	_tmp3_ = _tmp2_;
#line 156 "../core/Media.vala"
	g_string_append (_tmp1_, _tmp3_);
#line 157 "../core/Media.vala"
	_tmp4_ = noise_media_get_album_artist (self);
#line 157 "../core/Media.vala"
	_tmp5_ = _tmp4_;
#line 157 "../core/Media.vala"
	if (noise_media_is_valid_string_field (_tmp5_)) {
#line 808 "Media.c"
		GString* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 158 "../core/Media.vala"
		_tmp6_ = builder;
#line 158 "../core/Media.vala"
		_tmp7_ = noise_media_get_album_artist (self);
#line 158 "../core/Media.vala"
		_tmp8_ = _tmp7_;
#line 158 "../core/Media.vala"
		g_string_append (_tmp6_, _tmp8_);
#line 820 "Media.c"
	} else {
		GString* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 160 "../core/Media.vala"
		_tmp9_ = builder;
#line 160 "../core/Media.vala"
		_tmp10_ = noise_media_get_artist (self);
#line 160 "../core/Media.vala"
		_tmp11_ = _tmp10_;
#line 160 "../core/Media.vala"
		g_string_append (_tmp9_, _tmp11_);
#line 833 "Media.c"
	}
#line 161 "../core/Media.vala"
	_tmp12_ = builder;
#line 161 "../core/Media.vala"
	_tmp13_ = _tmp12_->str;
#line 161 "../core/Media.vala"
	result = g_str_hash (_tmp13_);
#line 161 "../core/Media.vala"
	_g_string_free0 (builder);
#line 161 "../core/Media.vala"
	return result;
#line 845 "Media.c"
}

/**
     * It's called simple because it simply checks if the string is empty,
     * and returns UNKNOWN if it is.
     */
inline gchar*
noise_media_get_simple_display_text (const gchar* text)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp2_;
#line 168 "../core/Media.vala"
	if (noise_media_is_valid_string_field (text)) {
#line 168 "../core/Media.vala"
		_tmp0_ = text;
#line 862 "Media.c"
	} else {
		const gchar* _tmp1_;
#line 168 "../core/Media.vala"
		_tmp1_ = noise_media_UNKNOWN;
#line 168 "../core/Media.vala"
		_tmp0_ = _tmp1_;
#line 869 "Media.c"
	}
#line 168 "../core/Media.vala"
	_tmp2_ = g_strdup (_tmp0_);
#line 168 "../core/Media.vala"
	result = _tmp2_;
#line 168 "../core/Media.vala"
	return result;
#line 877 "Media.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 899 "Media.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 903 "Media.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 909 "Media.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 913 "Media.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 917 "Media.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 925 "Media.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 953 "Media.c"
				goto __catch6_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 962 "Media.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 976 "Media.c"
				goto __catch6_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 987 "Media.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 1001 "Media.c"
	}
	goto __finally6;
	__catch6_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 1015 "Media.c"
	}
	__finally6:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 1026 "Media.c"
	}
}

gchar*
noise_media_get_title_markup (NoiseMedia* self)
{
	gchar* result = NULL;
	gboolean is_valid_artist = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean is_valid_album = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
#line 171 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 175 "../core/Media.vala"
	_tmp0_ = noise_media_get_artist (self);
#line 175 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 175 "../core/Media.vala"
	is_valid_artist = noise_media_is_valid_string_field (_tmp1_);
#line 176 "../core/Media.vala"
	_tmp2_ = noise_media_get_album (self);
#line 176 "../core/Media.vala"
	_tmp3_ = _tmp2_;
#line 176 "../core/Media.vala"
	is_valid_album = noise_media_is_valid_string_field (_tmp3_);
#line 177 "../core/Media.vala"
	if (!is_valid_artist) {
#line 177 "../core/Media.vala"
		_tmp4_ = is_valid_album;
#line 1059 "Media.c"
	} else {
#line 177 "../core/Media.vala"
		_tmp4_ = FALSE;
#line 1063 "Media.c"
	}
#line 177 "../core/Media.vala"
	if (_tmp4_) {
#line 1067 "Media.c"
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 179 "../core/Media.vala"
		_tmp5_ = noise_media_get_album (self);
#line 179 "../core/Media.vala"
		_tmp6_ = _tmp5_;
#line 179 "../core/Media.vala"
		_tmp7_ = g_markup_escape_text (_tmp6_, (gssize) -1);
#line 179 "../core/Media.vala"
		_tmp8_ = _tmp7_;
#line 179 "../core/Media.vala"
		_tmp9_ = g_strconcat ("<b>", _tmp8_, NULL);
#line 179 "../core/Media.vala"
		_tmp10_ = _tmp9_;
#line 179 "../core/Media.vala"
		_tmp11_ = g_strconcat (_tmp10_, "</b>", NULL);
#line 179 "../core/Media.vala"
		_tmp12_ = _tmp11_;
#line 179 "../core/Media.vala"
		_tmp13_ = string_replace (_ ("$NAME on $ALBUM"), "$ALBUM", _tmp12_);
#line 179 "../core/Media.vala"
		_tmp14_ = _tmp13_;
#line 179 "../core/Media.vala"
		_tmp15_ = noise_media_get_display_title (self);
#line 179 "../core/Media.vala"
		_tmp16_ = _tmp15_;
#line 179 "../core/Media.vala"
		_tmp17_ = g_markup_escape_text (_tmp16_, (gssize) -1);
#line 179 "../core/Media.vala"
		_tmp18_ = _tmp17_;
#line 179 "../core/Media.vala"
		_tmp19_ = g_strconcat ("<b>", _tmp18_, NULL);
#line 179 "../core/Media.vala"
		_tmp20_ = _tmp19_;
#line 179 "../core/Media.vala"
		_tmp21_ = g_strconcat (_tmp20_, "</b>", NULL);
#line 179 "../core/Media.vala"
		_tmp22_ = _tmp21_;
#line 179 "../core/Media.vala"
		_tmp23_ = string_replace (_tmp14_, "$NAME", _tmp22_);
#line 179 "../core/Media.vala"
		_tmp24_ = _tmp23_;
#line 179 "../core/Media.vala"
		_g_free0 (_tmp22_);
#line 179 "../core/Media.vala"
		_g_free0 (_tmp20_);
#line 179 "../core/Media.vala"
		_g_free0 (_tmp18_);
#line 179 "../core/Media.vala"
		_g_free0 (_tmp16_);
#line 179 "../core/Media.vala"
		_g_free0 (_tmp14_);
#line 179 "../core/Media.vala"
		_g_free0 (_tmp12_);
#line 179 "../core/Media.vala"
		_g_free0 (_tmp10_);
#line 179 "../core/Media.vala"
		_g_free0 (_tmp8_);
#line 179 "../core/Media.vala"
		result = _tmp24_;
#line 179 "../core/Media.vala"
		return result;
#line 1148 "Media.c"
	} else {
		gboolean _tmp25_ = FALSE;
#line 180 "../core/Media.vala"
		if (is_valid_artist) {
#line 180 "../core/Media.vala"
			_tmp25_ = !is_valid_album;
#line 1155 "Media.c"
		} else {
#line 180 "../core/Media.vala"
			_tmp25_ = FALSE;
#line 1159 "Media.c"
		}
#line 180 "../core/Media.vala"
		if (_tmp25_) {
#line 1163 "Media.c"
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			gchar* _tmp39_;
			gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			gchar* _tmp43_;
			gchar* _tmp44_;
			gchar* _tmp45_;
#line 182 "../core/Media.vala"
			_tmp26_ = noise_media_get_artist (self);
#line 182 "../core/Media.vala"
			_tmp27_ = _tmp26_;
#line 182 "../core/Media.vala"
			_tmp28_ = g_markup_escape_text (_tmp27_, (gssize) -1);
#line 182 "../core/Media.vala"
			_tmp29_ = _tmp28_;
#line 182 "../core/Media.vala"
			_tmp30_ = g_strconcat ("<b>", _tmp29_, NULL);
#line 182 "../core/Media.vala"
			_tmp31_ = _tmp30_;
#line 182 "../core/Media.vala"
			_tmp32_ = g_strconcat (_tmp31_, "</b>", NULL);
#line 182 "../core/Media.vala"
			_tmp33_ = _tmp32_;
#line 182 "../core/Media.vala"
			_tmp34_ = string_replace (_ ("$NAME by $ARTIST"), "$ARTIST", _tmp33_);
#line 182 "../core/Media.vala"
			_tmp35_ = _tmp34_;
#line 182 "../core/Media.vala"
			_tmp36_ = noise_media_get_display_title (self);
#line 182 "../core/Media.vala"
			_tmp37_ = _tmp36_;
#line 182 "../core/Media.vala"
			_tmp38_ = g_markup_escape_text (_tmp37_, (gssize) -1);
#line 182 "../core/Media.vala"
			_tmp39_ = _tmp38_;
#line 182 "../core/Media.vala"
			_tmp40_ = g_strconcat ("<b>", _tmp39_, NULL);
#line 182 "../core/Media.vala"
			_tmp41_ = _tmp40_;
#line 182 "../core/Media.vala"
			_tmp42_ = g_strconcat (_tmp41_, "</b>", NULL);
#line 182 "../core/Media.vala"
			_tmp43_ = _tmp42_;
#line 182 "../core/Media.vala"
			_tmp44_ = string_replace (_tmp35_, "$NAME", _tmp43_);
#line 182 "../core/Media.vala"
			_tmp45_ = _tmp44_;
#line 182 "../core/Media.vala"
			_g_free0 (_tmp43_);
#line 182 "../core/Media.vala"
			_g_free0 (_tmp41_);
#line 182 "../core/Media.vala"
			_g_free0 (_tmp39_);
#line 182 "../core/Media.vala"
			_g_free0 (_tmp37_);
#line 182 "../core/Media.vala"
			_g_free0 (_tmp35_);
#line 182 "../core/Media.vala"
			_g_free0 (_tmp33_);
#line 182 "../core/Media.vala"
			_g_free0 (_tmp31_);
#line 182 "../core/Media.vala"
			_g_free0 (_tmp29_);
#line 182 "../core/Media.vala"
			result = _tmp45_;
#line 182 "../core/Media.vala"
			return result;
#line 1244 "Media.c"
		} else {
			gboolean _tmp46_ = FALSE;
#line 183 "../core/Media.vala"
			if (!is_valid_artist) {
#line 183 "../core/Media.vala"
				_tmp46_ = !is_valid_album;
#line 1251 "Media.c"
			} else {
#line 183 "../core/Media.vala"
				_tmp46_ = FALSE;
#line 1255 "Media.c"
			}
#line 183 "../core/Media.vala"
			if (_tmp46_) {
#line 1259 "Media.c"
				gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				gchar* _tmp53_;
				gchar* _tmp54_;
#line 185 "../core/Media.vala"
				_tmp47_ = noise_media_get_display_title (self);
#line 185 "../core/Media.vala"
				_tmp48_ = _tmp47_;
#line 185 "../core/Media.vala"
				_tmp49_ = g_markup_escape_text (_tmp48_, (gssize) -1);
#line 185 "../core/Media.vala"
				_tmp50_ = _tmp49_;
#line 185 "../core/Media.vala"
				_tmp51_ = g_strconcat ("<b>", _tmp50_, NULL);
#line 185 "../core/Media.vala"
				_tmp52_ = _tmp51_;
#line 185 "../core/Media.vala"
				_tmp53_ = g_strconcat (_tmp52_, "</b>", NULL);
#line 185 "../core/Media.vala"
				_tmp54_ = _tmp53_;
#line 185 "../core/Media.vala"
				_g_free0 (_tmp52_);
#line 185 "../core/Media.vala"
				_g_free0 (_tmp50_);
#line 185 "../core/Media.vala"
				_g_free0 (_tmp48_);
#line 185 "../core/Media.vala"
				result = _tmp54_;
#line 185 "../core/Media.vala"
				return result;
#line 1294 "Media.c"
			} else {
				const gchar* _tmp55_;
				const gchar* _tmp56_;
				gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				gchar* _tmp61_;
				gchar* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
				gchar* _tmp66_;
				gchar* _tmp67_;
				gchar* _tmp68_;
				gchar* _tmp69_;
				gchar* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				gchar* _tmp74_;
				const gchar* _tmp75_;
				const gchar* _tmp76_;
				gchar* _tmp77_;
				gchar* _tmp78_;
				gchar* _tmp79_;
				gchar* _tmp80_;
				gchar* _tmp81_;
				gchar* _tmp82_;
				gchar* _tmp83_;
				gchar* _tmp84_;
#line 188 "../core/Media.vala"
				_tmp55_ = noise_media_get_artist (self);
#line 188 "../core/Media.vala"
				_tmp56_ = _tmp55_;
#line 188 "../core/Media.vala"
				_tmp57_ = g_markup_escape_text (_tmp56_, (gssize) -1);
#line 188 "../core/Media.vala"
				_tmp58_ = _tmp57_;
#line 188 "../core/Media.vala"
				_tmp59_ = g_strconcat ("<b>", _tmp58_, NULL);
#line 188 "../core/Media.vala"
				_tmp60_ = _tmp59_;
#line 188 "../core/Media.vala"
				_tmp61_ = g_strconcat (_tmp60_, "</b>", NULL);
#line 188 "../core/Media.vala"
				_tmp62_ = _tmp61_;
#line 188 "../core/Media.vala"
				_tmp63_ = string_replace (_ ("$NAME by $ARTIST on $ALBUM"), "$ARTIST", _tmp62_);
#line 188 "../core/Media.vala"
				_tmp64_ = _tmp63_;
#line 188 "../core/Media.vala"
				_tmp65_ = noise_media_get_display_title (self);
#line 188 "../core/Media.vala"
				_tmp66_ = _tmp65_;
#line 188 "../core/Media.vala"
				_tmp67_ = g_markup_escape_text (_tmp66_, (gssize) -1);
#line 188 "../core/Media.vala"
				_tmp68_ = _tmp67_;
#line 188 "../core/Media.vala"
				_tmp69_ = g_strconcat ("<b>", _tmp68_, NULL);
#line 188 "../core/Media.vala"
				_tmp70_ = _tmp69_;
#line 188 "../core/Media.vala"
				_tmp71_ = g_strconcat (_tmp70_, "</b>", NULL);
#line 188 "../core/Media.vala"
				_tmp72_ = _tmp71_;
#line 188 "../core/Media.vala"
				_tmp73_ = string_replace (_tmp64_, "$NAME", _tmp72_);
#line 188 "../core/Media.vala"
				_tmp74_ = _tmp73_;
#line 188 "../core/Media.vala"
				_tmp75_ = noise_media_get_album (self);
#line 188 "../core/Media.vala"
				_tmp76_ = _tmp75_;
#line 188 "../core/Media.vala"
				_tmp77_ = g_markup_escape_text (_tmp76_, (gssize) -1);
#line 188 "../core/Media.vala"
				_tmp78_ = _tmp77_;
#line 188 "../core/Media.vala"
				_tmp79_ = g_strconcat ("<b>", _tmp78_, NULL);
#line 188 "../core/Media.vala"
				_tmp80_ = _tmp79_;
#line 188 "../core/Media.vala"
				_tmp81_ = g_strconcat (_tmp80_, "</b>", NULL);
#line 188 "../core/Media.vala"
				_tmp82_ = _tmp81_;
#line 188 "../core/Media.vala"
				_tmp83_ = string_replace (_tmp74_, "$ALBUM", _tmp82_);
#line 188 "../core/Media.vala"
				_tmp84_ = _tmp83_;
#line 188 "../core/Media.vala"
				_g_free0 (_tmp82_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp80_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp78_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp74_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp72_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp70_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp68_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp66_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp64_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp62_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp60_);
#line 188 "../core/Media.vala"
				_g_free0 (_tmp58_);
#line 188 "../core/Media.vala"
				result = _tmp84_;
#line 188 "../core/Media.vala"
				return result;
#line 1414 "Media.c"
			}
		}
	}
}

NoiseMedia*
noise_media_construct (GType object_type,
                       const gchar* uri)
{
	NoiseMedia * self = NULL;
#line 192 "../core/Media.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 192 "../core/Media.vala"
	self = (NoiseMedia*) g_object_new (object_type, NULL);
#line 193 "../core/Media.vala"
	noise_media_set_uri (self, uri);
#line 192 "../core/Media.vala"
	return self;
#line 1433 "Media.c"
}

NoiseMedia*
noise_media_new (const gchar* uri)
{
#line 192 "../core/Media.vala"
	return noise_media_construct (NOISE_TYPE_MEDIA, uri);
#line 1441 "Media.c"
}

NoiseMedia*
noise_media_construct_from_file (GType object_type,
                                 GFile* file)
{
	NoiseMedia * self = NULL;
#line 196 "../core/Media.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 196 "../core/Media.vala"
	self = (NoiseMedia*) g_object_new (object_type, NULL);
#line 197 "../core/Media.vala"
	noise_media_set_file (self, file);
#line 196 "../core/Media.vala"
	return self;
#line 1457 "Media.c"
}

NoiseMedia*
noise_media_new_from_file (GFile* file)
{
#line 196 "../core/Media.vala"
	return noise_media_construct_from_file (NOISE_TYPE_MEDIA, file);
#line 1465 "Media.c"
}

NoiseMedia*
noise_media_copy (NoiseMedia* self)
{
	NoiseMedia* result = NULL;
	NoiseMedia* rv = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	NoiseMedia* _tmp3_;
	NoiseMedia* _tmp4_;
	guint64 _tmp5_;
	guint64 _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	guint _tmp9_;
	guint _tmp10_;
	guint _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	guint _tmp31_;
	guint _tmp32_;
	guint _tmp33_;
	guint _tmp34_;
	guint _tmp35_;
	guint _tmp36_;
	guint _tmp37_;
	guint _tmp38_;
	guint _tmp39_;
	guint _tmp40_;
	guint _tmp41_;
	guint _tmp42_;
	guint _tmp43_;
	guint _tmp44_;
	guint _tmp45_;
	guint _tmp46_;
	guint _tmp47_;
	guint _tmp48_;
	guint _tmp49_;
	guint _tmp50_;
	const gchar* _tmp51_;
	const gchar* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	guint _tmp57_;
	guint _tmp58_;
	gboolean _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_;
	GIcon* _tmp63_;
	GIcon* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
#line 200 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 201 "../core/Media.vala"
	_tmp0_ = noise_media_get_uri (self);
#line 201 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 201 "../core/Media.vala"
	_tmp2_ = _tmp1_;
#line 201 "../core/Media.vala"
	_tmp3_ = noise_media_new (_tmp2_);
#line 201 "../core/Media.vala"
	_tmp4_ = _tmp3_;
#line 201 "../core/Media.vala"
	_g_free0 (_tmp2_);
#line 201 "../core/Media.vala"
	rv = _tmp4_;
#line 203 "../core/Media.vala"
	_tmp5_ = noise_media_get_file_size (self);
#line 203 "../core/Media.vala"
	_tmp6_ = _tmp5_;
#line 203 "../core/Media.vala"
	noise_media_set_file_size (rv, _tmp6_);
#line 204 "../core/Media.vala"
	_tmp7_ = noise_media_get_track (self);
#line 204 "../core/Media.vala"
	_tmp8_ = _tmp7_;
#line 204 "../core/Media.vala"
	noise_media_set_track (rv, _tmp8_);
#line 205 "../core/Media.vala"
	_tmp9_ = noise_media_get_track_count (self);
#line 205 "../core/Media.vala"
	_tmp10_ = _tmp9_;
#line 205 "../core/Media.vala"
	noise_media_set_track_count (rv, _tmp10_);
#line 206 "../core/Media.vala"
	_tmp11_ = noise_media_get_album_number (self);
#line 206 "../core/Media.vala"
	_tmp12_ = _tmp11_;
#line 206 "../core/Media.vala"
	noise_media_set_album_number (rv, _tmp12_);
#line 207 "../core/Media.vala"
	_tmp13_ = noise_media_get_album_count (self);
#line 207 "../core/Media.vala"
	_tmp14_ = _tmp13_;
#line 207 "../core/Media.vala"
	noise_media_set_album_count (rv, _tmp14_);
#line 208 "../core/Media.vala"
	_tmp15_ = noise_media_get_title (self);
#line 208 "../core/Media.vala"
	_tmp16_ = _tmp15_;
#line 208 "../core/Media.vala"
	noise_media_set_title (rv, _tmp16_);
#line 209 "../core/Media.vala"
	_tmp17_ = noise_media_get_artist (self);
#line 209 "../core/Media.vala"
	_tmp18_ = _tmp17_;
#line 209 "../core/Media.vala"
	noise_media_set_artist (rv, _tmp18_);
#line 210 "../core/Media.vala"
	_tmp19_ = noise_media_get_composer (self);
#line 210 "../core/Media.vala"
	_tmp20_ = _tmp19_;
#line 210 "../core/Media.vala"
	noise_media_set_composer (rv, _tmp20_);
#line 211 "../core/Media.vala"
	_tmp21_ = noise_media_get_album_artist (self);
#line 211 "../core/Media.vala"
	_tmp22_ = _tmp21_;
#line 211 "../core/Media.vala"
	noise_media_set_album_artist (rv, _tmp22_);
#line 212 "../core/Media.vala"
	_tmp23_ = noise_media_get_album (self);
#line 212 "../core/Media.vala"
	_tmp24_ = _tmp23_;
#line 212 "../core/Media.vala"
	noise_media_set_album (rv, _tmp24_);
#line 213 "../core/Media.vala"
	_tmp25_ = noise_media_get_genre (self);
#line 213 "../core/Media.vala"
	_tmp26_ = _tmp25_;
#line 213 "../core/Media.vala"
	noise_media_set_genre (rv, _tmp26_);
#line 214 "../core/Media.vala"
	_tmp27_ = noise_media_get_grouping (self);
#line 214 "../core/Media.vala"
	_tmp28_ = _tmp27_;
#line 214 "../core/Media.vala"
	noise_media_set_grouping (rv, _tmp28_);
#line 215 "../core/Media.vala"
	_tmp29_ = noise_media_get_comment (self);
#line 215 "../core/Media.vala"
	_tmp30_ = _tmp29_;
#line 215 "../core/Media.vala"
	noise_media_set_comment (rv, _tmp30_);
#line 216 "../core/Media.vala"
	_tmp31_ = noise_media_get_year (self);
#line 216 "../core/Media.vala"
	_tmp32_ = _tmp31_;
#line 216 "../core/Media.vala"
	noise_media_set_year (rv, _tmp32_);
#line 217 "../core/Media.vala"
	_tmp33_ = noise_media_get_bitrate (self);
#line 217 "../core/Media.vala"
	_tmp34_ = _tmp33_;
#line 217 "../core/Media.vala"
	noise_media_set_bitrate (rv, _tmp34_);
#line 218 "../core/Media.vala"
	_tmp35_ = noise_media_get_length (self);
#line 218 "../core/Media.vala"
	_tmp36_ = _tmp35_;
#line 218 "../core/Media.vala"
	noise_media_set_length (rv, _tmp36_);
#line 219 "../core/Media.vala"
	_tmp37_ = noise_media_get_samplerate (self);
#line 219 "../core/Media.vala"
	_tmp38_ = _tmp37_;
#line 219 "../core/Media.vala"
	noise_media_set_samplerate (rv, _tmp38_);
#line 220 "../core/Media.vala"
	_tmp39_ = noise_media_get_bpm (self);
#line 220 "../core/Media.vala"
	_tmp40_ = _tmp39_;
#line 220 "../core/Media.vala"
	noise_media_set_bpm (rv, _tmp40_);
#line 221 "../core/Media.vala"
	_tmp41_ = noise_media_get_rating (self);
#line 221 "../core/Media.vala"
	_tmp42_ = _tmp41_;
#line 221 "../core/Media.vala"
	noise_media_set_rating (rv, _tmp42_);
#line 222 "../core/Media.vala"
	_tmp43_ = noise_media_get_play_count (self);
#line 222 "../core/Media.vala"
	_tmp44_ = _tmp43_;
#line 222 "../core/Media.vala"
	noise_media_set_play_count (rv, _tmp44_);
#line 223 "../core/Media.vala"
	_tmp45_ = noise_media_get_skip_count (self);
#line 223 "../core/Media.vala"
	_tmp46_ = _tmp45_;
#line 223 "../core/Media.vala"
	noise_media_set_skip_count (rv, _tmp46_);
#line 224 "../core/Media.vala"
	_tmp47_ = noise_media_get_date_added (self);
#line 224 "../core/Media.vala"
	_tmp48_ = _tmp47_;
#line 224 "../core/Media.vala"
	noise_media_set_date_added (rv, _tmp48_);
#line 225 "../core/Media.vala"
	_tmp49_ = noise_media_get_last_played (self);
#line 225 "../core/Media.vala"
	_tmp50_ = _tmp49_;
#line 225 "../core/Media.vala"
	noise_media_set_last_played (rv, _tmp50_);
#line 226 "../core/Media.vala"
	_tmp51_ = noise_media_get_lyrics (self);
#line 226 "../core/Media.vala"
	_tmp52_ = _tmp51_;
#line 226 "../core/Media.vala"
	noise_media_set_lyrics (rv, _tmp52_);
#line 227 "../core/Media.vala"
	_tmp53_ = noise_media_get_isPreview (self);
#line 227 "../core/Media.vala"
	_tmp54_ = _tmp53_;
#line 227 "../core/Media.vala"
	noise_media_set_isPreview (rv, _tmp54_);
#line 228 "../core/Media.vala"
	_tmp55_ = noise_media_get_isTemporary (self);
#line 228 "../core/Media.vala"
	_tmp56_ = _tmp55_;
#line 228 "../core/Media.vala"
	noise_media_set_isTemporary (rv, _tmp56_);
#line 229 "../core/Media.vala"
	_tmp57_ = noise_media_get_last_modified (self);
#line 229 "../core/Media.vala"
	_tmp58_ = _tmp57_;
#line 229 "../core/Media.vala"
	noise_media_set_last_modified (rv, _tmp58_);
#line 230 "../core/Media.vala"
	_tmp59_ = noise_media_get_show (self);
#line 230 "../core/Media.vala"
	_tmp60_ = _tmp59_;
#line 230 "../core/Media.vala"
	noise_media_set_show (rv, _tmp60_);
#line 231 "../core/Media.vala"
	_tmp61_ = noise_media_get_showIndicator (self);
#line 231 "../core/Media.vala"
	_tmp62_ = _tmp61_;
#line 231 "../core/Media.vala"
	noise_media_set_showIndicator (rv, _tmp62_);
#line 232 "../core/Media.vala"
	_tmp63_ = noise_media_get_unique_status_image (self);
#line 232 "../core/Media.vala"
	_tmp64_ = _tmp63_;
#line 232 "../core/Media.vala"
	noise_media_set_unique_status_image (rv, _tmp64_);
#line 233 "../core/Media.vala"
	_tmp65_ = noise_media_get_location_unknown (self);
#line 233 "../core/Media.vala"
	_tmp66_ = _tmp65_;
#line 233 "../core/Media.vala"
	noise_media_set_location_unknown (rv, _tmp66_);
#line 235 "../core/Media.vala"
	result = rv;
#line 235 "../core/Media.vala"
	return result;
#line 1746 "Media.c"
}

gint64
noise_media_get_rowid (NoiseMedia* self)
{
	gint64 result;
#line 34 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 34 "../core/Media.vala"
	result = self->priv->_rowid;
#line 34 "../core/Media.vala"
	return result;
#line 1759 "Media.c"
}

void
noise_media_set_rowid (NoiseMedia* self,
                       gint64 value)
{
#line 34 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 34 "../core/Media.vala"
	if (noise_media_get_rowid (self) != value) {
#line 34 "../core/Media.vala"
		self->priv->_rowid = value;
#line 34 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ROWID_PROPERTY]);
#line 1774 "Media.c"
	}
}

gchar*
noise_media_get_uri (NoiseMedia* self)
{
#line 37 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_uri (self);
#line 1785 "Media.c"
}

static gchar*
noise_media_real_get_uri (NoiseMedia* base)
{
	gchar* result;
	NoiseMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
#line 37 "../core/Media.vala"
	self = base;
#line 37 "../core/Media.vala"
	_tmp0_ = noise_media_get_file (self);
#line 37 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 37 "../core/Media.vala"
	_tmp2_ = g_file_get_uri (_tmp1_);
#line 37 "../core/Media.vala"
	result = _tmp2_;
#line 37 "../core/Media.vala"
	return result;
#line 1808 "Media.c"
}

void
noise_media_set_uri (NoiseMedia* self,
                     const gchar* value)
{
#line 38 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 38 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_uri (self, value);
#line 1819 "Media.c"
}

static void
noise_media_real_set_uri (NoiseMedia* base,
                          const gchar* value)
{
	NoiseMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 38 "../core/Media.vala"
	self = base;
#line 38 "../core/Media.vala"
	_tmp0_ = g_file_new_for_uri (value);
#line 38 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 38 "../core/Media.vala"
	noise_media_set_file (self, _tmp1_);
#line 38 "../core/Media.vala"
	_g_object_unref0 (_tmp1_);
#line 38 "../core/Media.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_URI_PROPERTY]);
#line 1841 "Media.c"
}

guint64
noise_media_get_file_size (NoiseMedia* self)
{
#line 41 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 41 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_file_size (self);
#line 1851 "Media.c"
}

static guint64
noise_media_real_get_file_size (NoiseMedia* base)
{
	guint64 result;
	NoiseMedia* self;
#line 41 "../core/Media.vala"
	self = base;
#line 41 "../core/Media.vala"
	result = self->priv->_file_size;
#line 41 "../core/Media.vala"
	return result;
#line 1865 "Media.c"
}

void
noise_media_set_file_size (NoiseMedia* self,
                           guint64 value)
{
#line 41 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 41 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_file_size (self, value);
#line 1876 "Media.c"
}

static void
noise_media_real_set_file_size (NoiseMedia* base,
                                guint64 value)
{
	NoiseMedia* self;
#line 41 "../core/Media.vala"
	self = base;
#line 41 "../core/Media.vala"
	if (noise_media_real_get_file_size (base) != value) {
#line 41 "../core/Media.vala"
		self->priv->_file_size = value;
#line 41 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_FILE_SIZE_PROPERTY]);
#line 1892 "Media.c"
	}
}

gboolean
noise_media_get_file_exists (NoiseMedia* self)
{
#line 42 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_file_exists (self);
#line 1903 "Media.c"
}

static gboolean
noise_media_real_get_file_exists (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
#line 42 "../core/Media.vala"
	self = base;
#line 42 "../core/Media.vala"
	_tmp0_ = noise_media_get_file (self);
#line 42 "../core/Media.vala"
	_tmp1_ = _tmp0_;
#line 42 "../core/Media.vala"
	result = g_file_query_exists (_tmp1_, NULL);
#line 42 "../core/Media.vala"
	return result;
#line 1923 "Media.c"
}

GFile*
noise_media_get_file (NoiseMedia* self)
{
#line 44 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 44 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_file (self);
#line 1933 "Media.c"
}

static GFile*
noise_media_real_get_file (NoiseMedia* base)
{
	GFile* result;
	NoiseMedia* self;
	GFile* _tmp0_;
#line 44 "../core/Media.vala"
	self = base;
#line 44 "../core/Media.vala"
	_tmp0_ = self->priv->_file;
#line 44 "../core/Media.vala"
	result = _tmp0_;
#line 44 "../core/Media.vala"
	return result;
#line 1950 "Media.c"
}

void
noise_media_set_file (NoiseMedia* self,
                      GFile* value)
{
#line 44 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 44 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_file (self, value);
#line 1961 "Media.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 44 "../core/Media.vala"
	return self ? g_object_ref (self) : NULL;
#line 1969 "Media.c"
}

static void
noise_media_real_set_file (NoiseMedia* base,
                           GFile* value)
{
	NoiseMedia* self;
#line 44 "../core/Media.vala"
	self = base;
#line 44 "../core/Media.vala"
	if (noise_media_real_get_file (base) != value) {
#line 1981 "Media.c"
		GFile* _tmp0_;
#line 44 "../core/Media.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 44 "../core/Media.vala"
		_g_object_unref0 (self->priv->_file);
#line 44 "../core/Media.vala"
		self->priv->_file = _tmp0_;
#line 44 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_FILE_PROPERTY]);
#line 1991 "Media.c"
	}
}

gboolean
noise_media_get_isPreview (NoiseMedia* self)
{
#line 46 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_isPreview (self);
#line 2002 "Media.c"
}

static gboolean
noise_media_real_get_isPreview (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
#line 46 "../core/Media.vala"
	self = base;
#line 46 "../core/Media.vala"
	result = self->priv->_isPreview;
#line 46 "../core/Media.vala"
	return result;
#line 2016 "Media.c"
}

void
noise_media_set_isPreview (NoiseMedia* self,
                           gboolean value)
{
#line 46 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 46 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_isPreview (self, value);
#line 2027 "Media.c"
}

static void
noise_media_real_set_isPreview (NoiseMedia* base,
                                gboolean value)
{
	NoiseMedia* self;
#line 46 "../core/Media.vala"
	self = base;
#line 46 "../core/Media.vala"
	if (noise_media_real_get_isPreview (base) != value) {
#line 46 "../core/Media.vala"
		self->priv->_isPreview = value;
#line 46 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_IS_PREVIEW_PROPERTY]);
#line 2043 "Media.c"
	}
}

gboolean
noise_media_get_isTemporary (NoiseMedia* self)
{
#line 47 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 47 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_isTemporary (self);
#line 2054 "Media.c"
}

static gboolean
noise_media_real_get_isTemporary (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
#line 47 "../core/Media.vala"
	self = base;
#line 47 "../core/Media.vala"
	result = self->priv->_isTemporary;
#line 47 "../core/Media.vala"
	return result;
#line 2068 "Media.c"
}

void
noise_media_set_isTemporary (NoiseMedia* self,
                             gboolean value)
{
#line 47 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 47 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_isTemporary (self, value);
#line 2079 "Media.c"
}

static void
noise_media_real_set_isTemporary (NoiseMedia* base,
                                  gboolean value)
{
	NoiseMedia* self;
#line 47 "../core/Media.vala"
	self = base;
#line 47 "../core/Media.vala"
	if (noise_media_real_get_isTemporary (base) != value) {
#line 47 "../core/Media.vala"
		self->priv->_isTemporary = value;
#line 47 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_IS_TEMPORARY_PROPERTY]);
#line 2095 "Media.c"
	}
}

gboolean
noise_media_get_location_unknown (NoiseMedia* self)
{
#line 50 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_location_unknown (self);
#line 2106 "Media.c"
}

static gboolean
noise_media_real_get_location_unknown (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
#line 50 "../core/Media.vala"
	self = base;
#line 50 "../core/Media.vala"
	result = self->priv->_location_unknown;
#line 50 "../core/Media.vala"
	return result;
#line 2120 "Media.c"
}

void
noise_media_set_location_unknown (NoiseMedia* self,
                                  gboolean value)
{
#line 50 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 50 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_location_unknown (self, value);
#line 2131 "Media.c"
}

static void
noise_media_real_set_location_unknown (NoiseMedia* base,
                                       gboolean value)
{
	NoiseMedia* self;
#line 50 "../core/Media.vala"
	self = base;
#line 50 "../core/Media.vala"
	if (noise_media_real_get_location_unknown (base) != value) {
#line 50 "../core/Media.vala"
		self->priv->_location_unknown = value;
#line 50 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY]);
#line 2147 "Media.c"
	}
}

gboolean
noise_media_get_has_embedded (NoiseMedia* self)
{
#line 51 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_has_embedded (self);
#line 2158 "Media.c"
}

static gboolean
noise_media_real_get_has_embedded (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
#line 51 "../core/Media.vala"
	self = base;
#line 51 "../core/Media.vala"
	result = self->priv->_has_embedded;
#line 51 "../core/Media.vala"
	return result;
#line 2172 "Media.c"
}

void
noise_media_set_has_embedded (NoiseMedia* self,
                              gboolean value)
{
#line 51 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 51 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_has_embedded (self, value);
#line 2183 "Media.c"
}

static void
noise_media_real_set_has_embedded (NoiseMedia* base,
                                   gboolean value)
{
	NoiseMedia* self;
#line 51 "../core/Media.vala"
	self = base;
#line 51 "../core/Media.vala"
	if (noise_media_real_get_has_embedded (base) != value) {
#line 51 "../core/Media.vala"
		self->priv->_has_embedded = value;
#line 51 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_HAS_EMBEDDED_PROPERTY]);
#line 2199 "Media.c"
	}
}

GIcon*
noise_media_get_unique_status_image (NoiseMedia* self)
{
#line 55 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 55 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_unique_status_image (self);
#line 2210 "Media.c"
}

static GIcon*
noise_media_real_get_unique_status_image (NoiseMedia* base)
{
	GIcon* result;
	NoiseMedia* self;
	GIcon* _tmp0_;
#line 55 "../core/Media.vala"
	self = base;
#line 55 "../core/Media.vala"
	_tmp0_ = self->priv->_unique_status_image;
#line 55 "../core/Media.vala"
	result = _tmp0_;
#line 55 "../core/Media.vala"
	return result;
#line 2227 "Media.c"
}

void
noise_media_set_unique_status_image (NoiseMedia* self,
                                     GIcon* value)
{
#line 55 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 55 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_unique_status_image (self, value);
#line 2238 "Media.c"
}

static void
noise_media_real_set_unique_status_image (NoiseMedia* base,
                                          GIcon* value)
{
	NoiseMedia* self;
#line 55 "../core/Media.vala"
	self = base;
#line 55 "../core/Media.vala"
	if (noise_media_real_get_unique_status_image (base) != value) {
#line 2250 "Media.c"
		GIcon* _tmp0_;
#line 55 "../core/Media.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 55 "../core/Media.vala"
		_g_object_unref0 (self->priv->_unique_status_image);
#line 55 "../core/Media.vala"
		self->priv->_unique_status_image = _tmp0_;
#line 55 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY]);
#line 2260 "Media.c"
	}
}

gboolean
noise_media_get_showIndicator (NoiseMedia* self)
{
#line 56 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 56 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_showIndicator (self);
#line 2271 "Media.c"
}

static gboolean
noise_media_real_get_showIndicator (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
#line 56 "../core/Media.vala"
	self = base;
#line 56 "../core/Media.vala"
	result = self->priv->_showIndicator;
#line 56 "../core/Media.vala"
	return result;
#line 2285 "Media.c"
}

void
noise_media_set_showIndicator (NoiseMedia* self,
                               gboolean value)
{
#line 56 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 56 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_showIndicator (self, value);
#line 2296 "Media.c"
}

static void
noise_media_real_set_showIndicator (NoiseMedia* base,
                                    gboolean value)
{
	NoiseMedia* self;
#line 56 "../core/Media.vala"
	self = base;
#line 56 "../core/Media.vala"
	if (noise_media_real_get_showIndicator (base) != value) {
#line 56 "../core/Media.vala"
		self->priv->_showIndicator = value;
#line 56 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SHOW_INDICATOR_PROPERTY]);
#line 2312 "Media.c"
	}
}

const gchar*
noise_media_get_title (NoiseMedia* self)
{
#line 61 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_title (self);
#line 2323 "Media.c"
}

static const gchar*
noise_media_real_get_title (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 61 "../core/Media.vala"
	self = base;
#line 61 "../core/Media.vala"
	_tmp0_ = self->priv->_title;
#line 61 "../core/Media.vala"
	result = _tmp0_;
#line 61 "../core/Media.vala"
	return result;
#line 2340 "Media.c"
}

void
noise_media_set_title (NoiseMedia* self,
                       const gchar* value)
{
#line 61 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 61 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_title (self, value);
#line 2351 "Media.c"
}

static void
noise_media_real_set_title (NoiseMedia* base,
                            const gchar* value)
{
	NoiseMedia* self;
#line 61 "../core/Media.vala"
	self = base;
#line 61 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_title (base)) != 0) {
#line 2363 "Media.c"
		gchar* _tmp0_;
#line 61 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 61 "../core/Media.vala"
		_g_free0 (self->priv->_title);
#line 61 "../core/Media.vala"
		self->priv->_title = _tmp0_;
#line 61 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_TITLE_PROPERTY]);
#line 2373 "Media.c"
	}
}

guint
noise_media_get_track (NoiseMedia* self)
{
#line 62 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 62 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_track (self);
#line 2384 "Media.c"
}

static guint
noise_media_real_get_track (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 62 "../core/Media.vala"
	self = base;
#line 62 "../core/Media.vala"
	result = self->priv->_track;
#line 62 "../core/Media.vala"
	return result;
#line 2398 "Media.c"
}

void
noise_media_set_track (NoiseMedia* self,
                       guint value)
{
#line 62 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 62 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_track (self, value);
#line 2409 "Media.c"
}

static void
noise_media_real_set_track (NoiseMedia* base,
                            guint value)
{
	NoiseMedia* self;
#line 62 "../core/Media.vala"
	self = base;
#line 62 "../core/Media.vala"
	if (noise_media_real_get_track (base) != value) {
#line 62 "../core/Media.vala"
		self->priv->_track = value;
#line 62 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_TRACK_PROPERTY]);
#line 2425 "Media.c"
	}
}

guint
noise_media_get_track_count (NoiseMedia* self)
{
#line 63 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 63 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_track_count (self);
#line 2436 "Media.c"
}

static guint
noise_media_real_get_track_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 63 "../core/Media.vala"
	self = base;
#line 63 "../core/Media.vala"
	result = self->priv->_track_count;
#line 63 "../core/Media.vala"
	return result;
#line 2450 "Media.c"
}

void
noise_media_set_track_count (NoiseMedia* self,
                             guint value)
{
#line 63 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 63 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_track_count (self, value);
#line 2461 "Media.c"
}

static void
noise_media_real_set_track_count (NoiseMedia* base,
                                  guint value)
{
	NoiseMedia* self;
#line 63 "../core/Media.vala"
	self = base;
#line 63 "../core/Media.vala"
	if (noise_media_real_get_track_count (base) != value) {
#line 63 "../core/Media.vala"
		self->priv->_track_count = value;
#line 63 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_TRACK_COUNT_PROPERTY]);
#line 2477 "Media.c"
	}
}

const gchar*
noise_media_get_composer (NoiseMedia* self)
{
#line 64 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 64 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_composer (self);
#line 2488 "Media.c"
}

static const gchar*
noise_media_real_get_composer (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 64 "../core/Media.vala"
	self = base;
#line 64 "../core/Media.vala"
	_tmp0_ = self->priv->_composer;
#line 64 "../core/Media.vala"
	result = _tmp0_;
#line 64 "../core/Media.vala"
	return result;
#line 2505 "Media.c"
}

void
noise_media_set_composer (NoiseMedia* self,
                          const gchar* value)
{
#line 64 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 64 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_composer (self, value);
#line 2516 "Media.c"
}

static void
noise_media_real_set_composer (NoiseMedia* base,
                               const gchar* value)
{
	NoiseMedia* self;
#line 64 "../core/Media.vala"
	self = base;
#line 64 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_composer (base)) != 0) {
#line 2528 "Media.c"
		gchar* _tmp0_;
#line 64 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 64 "../core/Media.vala"
		_g_free0 (self->priv->_composer);
#line 64 "../core/Media.vala"
		self->priv->_composer = _tmp0_;
#line 64 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_COMPOSER_PROPERTY]);
#line 2538 "Media.c"
	}
}

const gchar*
noise_media_get_artist (NoiseMedia* self)
{
#line 65 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 65 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_artist (self);
#line 2549 "Media.c"
}

static const gchar*
noise_media_real_get_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 65 "../core/Media.vala"
	self = base;
#line 65 "../core/Media.vala"
	_tmp0_ = self->priv->_artist;
#line 65 "../core/Media.vala"
	result = _tmp0_;
#line 65 "../core/Media.vala"
	return result;
#line 2566 "Media.c"
}

void
noise_media_set_artist (NoiseMedia* self,
                        const gchar* value)
{
#line 65 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 65 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_artist (self, value);
#line 2577 "Media.c"
}

static void
noise_media_real_set_artist (NoiseMedia* base,
                             const gchar* value)
{
	NoiseMedia* self;
#line 65 "../core/Media.vala"
	self = base;
#line 65 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_artist (base)) != 0) {
#line 2589 "Media.c"
		gchar* _tmp0_;
#line 65 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 65 "../core/Media.vala"
		_g_free0 (self->priv->_artist);
#line 65 "../core/Media.vala"
		self->priv->_artist = _tmp0_;
#line 65 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ARTIST_PROPERTY]);
#line 2599 "Media.c"
	}
}

const gchar*
noise_media_get_album_artist (NoiseMedia* self)
{
#line 66 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 66 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_artist (self);
#line 2610 "Media.c"
}

static const gchar*
noise_media_real_get_album_artist (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 66 "../core/Media.vala"
	self = base;
#line 66 "../core/Media.vala"
	_tmp0_ = self->priv->_album_artist;
#line 66 "../core/Media.vala"
	result = _tmp0_;
#line 66 "../core/Media.vala"
	return result;
#line 2627 "Media.c"
}

void
noise_media_set_album_artist (NoiseMedia* self,
                              const gchar* value)
{
#line 66 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 66 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_artist (self, value);
#line 2638 "Media.c"
}

static void
noise_media_real_set_album_artist (NoiseMedia* base,
                                   const gchar* value)
{
	NoiseMedia* self;
#line 66 "../core/Media.vala"
	self = base;
#line 66 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_album_artist (base)) != 0) {
#line 2650 "Media.c"
		gchar* _tmp0_;
#line 66 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 66 "../core/Media.vala"
		_g_free0 (self->priv->_album_artist);
#line 66 "../core/Media.vala"
		self->priv->_album_artist = _tmp0_;
#line 66 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_ARTIST_PROPERTY]);
#line 2660 "Media.c"
	}
}

const gchar*
noise_media_get_album (NoiseMedia* self)
{
#line 67 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 67 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album (self);
#line 2671 "Media.c"
}

static const gchar*
noise_media_real_get_album (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 67 "../core/Media.vala"
	self = base;
#line 67 "../core/Media.vala"
	_tmp0_ = self->priv->_album;
#line 67 "../core/Media.vala"
	result = _tmp0_;
#line 67 "../core/Media.vala"
	return result;
#line 2688 "Media.c"
}

void
noise_media_set_album (NoiseMedia* self,
                       const gchar* value)
{
#line 67 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 67 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album (self, value);
#line 2699 "Media.c"
}

static void
noise_media_real_set_album (NoiseMedia* base,
                            const gchar* value)
{
	NoiseMedia* self;
#line 67 "../core/Media.vala"
	self = base;
#line 67 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_album (base)) != 0) {
#line 2711 "Media.c"
		gchar* _tmp0_;
#line 67 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 67 "../core/Media.vala"
		_g_free0 (self->priv->_album);
#line 67 "../core/Media.vala"
		self->priv->_album = _tmp0_;
#line 67 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_PROPERTY]);
#line 2721 "Media.c"
	}
}

guint
noise_media_get_album_number (NoiseMedia* self)
{
#line 68 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 68 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_number (self);
#line 2732 "Media.c"
}

static guint
noise_media_real_get_album_number (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 68 "../core/Media.vala"
	self = base;
#line 68 "../core/Media.vala"
	result = self->priv->_album_number;
#line 68 "../core/Media.vala"
	return result;
#line 2746 "Media.c"
}

void
noise_media_set_album_number (NoiseMedia* self,
                              guint value)
{
#line 68 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 68 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_number (self, value);
#line 2757 "Media.c"
}

static void
noise_media_real_set_album_number (NoiseMedia* base,
                                   guint value)
{
	NoiseMedia* self;
#line 68 "../core/Media.vala"
	self = base;
#line 68 "../core/Media.vala"
	if (noise_media_real_get_album_number (base) != value) {
#line 68 "../core/Media.vala"
		self->priv->_album_number = value;
#line 68 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_NUMBER_PROPERTY]);
#line 2773 "Media.c"
	}
}

guint
noise_media_get_album_count (NoiseMedia* self)
{
#line 69 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 69 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_count (self);
#line 2784 "Media.c"
}

static guint
noise_media_real_get_album_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 69 "../core/Media.vala"
	self = base;
#line 69 "../core/Media.vala"
	result = self->priv->_album_count;
#line 69 "../core/Media.vala"
	return result;
#line 2798 "Media.c"
}

void
noise_media_set_album_count (NoiseMedia* self,
                             guint value)
{
#line 69 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 69 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_count (self, value);
#line 2809 "Media.c"
}

static void
noise_media_real_set_album_count (NoiseMedia* base,
                                  guint value)
{
	NoiseMedia* self;
#line 69 "../core/Media.vala"
	self = base;
#line 69 "../core/Media.vala"
	if (noise_media_real_get_album_count (base) != value) {
#line 69 "../core/Media.vala"
		self->priv->_album_count = value;
#line 69 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_COUNT_PROPERTY]);
#line 2825 "Media.c"
	}
}

NoiseAlbum*
noise_media_get_album_info (NoiseMedia* self)
{
#line 70 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_album_info (self);
#line 2836 "Media.c"
}

static NoiseAlbum*
noise_media_real_get_album_info (NoiseMedia* base)
{
	NoiseAlbum* result;
	NoiseMedia* self;
	NoiseAlbum* _tmp0_;
#line 70 "../core/Media.vala"
	self = base;
#line 70 "../core/Media.vala"
	_tmp0_ = self->priv->_album_info;
#line 70 "../core/Media.vala"
	result = _tmp0_;
#line 70 "../core/Media.vala"
	return result;
#line 2853 "Media.c"
}

void
noise_media_set_album_info (NoiseMedia* self,
                            NoiseAlbum* value)
{
#line 70 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 70 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_album_info (self, value);
#line 2864 "Media.c"
}

static void
noise_media_real_set_album_info (NoiseMedia* base,
                                 NoiseAlbum* value)
{
	NoiseMedia* self;
#line 70 "../core/Media.vala"
	self = base;
#line 70 "../core/Media.vala"
	if (noise_media_real_get_album_info (base) != value) {
#line 70 "../core/Media.vala"
		self->priv->_album_info = value;
#line 70 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_ALBUM_INFO_PROPERTY]);
#line 2880 "Media.c"
	}
}

const gchar*
noise_media_get_grouping (NoiseMedia* self)
{
#line 71 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 71 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_grouping (self);
#line 2891 "Media.c"
}

static const gchar*
noise_media_real_get_grouping (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 71 "../core/Media.vala"
	self = base;
#line 71 "../core/Media.vala"
	_tmp0_ = self->priv->_grouping;
#line 71 "../core/Media.vala"
	result = _tmp0_;
#line 71 "../core/Media.vala"
	return result;
#line 2908 "Media.c"
}

void
noise_media_set_grouping (NoiseMedia* self,
                          const gchar* value)
{
#line 71 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 71 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_grouping (self, value);
#line 2919 "Media.c"
}

static void
noise_media_real_set_grouping (NoiseMedia* base,
                               const gchar* value)
{
	NoiseMedia* self;
#line 71 "../core/Media.vala"
	self = base;
#line 71 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_grouping (base)) != 0) {
#line 2931 "Media.c"
		gchar* _tmp0_;
#line 71 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 71 "../core/Media.vala"
		_g_free0 (self->priv->_grouping);
#line 71 "../core/Media.vala"
		self->priv->_grouping = _tmp0_;
#line 71 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_GROUPING_PROPERTY]);
#line 2941 "Media.c"
	}
}

const gchar*
noise_media_get_genre (NoiseMedia* self)
{
#line 72 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_genre (self);
#line 2952 "Media.c"
}

static const gchar*
noise_media_real_get_genre (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 72 "../core/Media.vala"
	self = base;
#line 72 "../core/Media.vala"
	_tmp0_ = self->priv->_genre;
#line 72 "../core/Media.vala"
	result = _tmp0_;
#line 72 "../core/Media.vala"
	return result;
#line 2969 "Media.c"
}

void
noise_media_set_genre (NoiseMedia* self,
                       const gchar* value)
{
#line 72 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 72 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_genre (self, value);
#line 2980 "Media.c"
}

static void
noise_media_real_set_genre (NoiseMedia* base,
                            const gchar* value)
{
	NoiseMedia* self;
#line 72 "../core/Media.vala"
	self = base;
#line 72 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_genre (base)) != 0) {
#line 2992 "Media.c"
		gchar* _tmp0_;
#line 72 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 72 "../core/Media.vala"
		_g_free0 (self->priv->_genre);
#line 72 "../core/Media.vala"
		self->priv->_genre = _tmp0_;
#line 72 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_GENRE_PROPERTY]);
#line 3002 "Media.c"
	}
}

const gchar*
noise_media_get_comment (NoiseMedia* self)
{
#line 73 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 73 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_comment (self);
#line 3013 "Media.c"
}

static const gchar*
noise_media_real_get_comment (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 73 "../core/Media.vala"
	self = base;
#line 73 "../core/Media.vala"
	_tmp0_ = self->priv->_comment;
#line 73 "../core/Media.vala"
	result = _tmp0_;
#line 73 "../core/Media.vala"
	return result;
#line 3030 "Media.c"
}

void
noise_media_set_comment (NoiseMedia* self,
                         const gchar* value)
{
#line 73 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 73 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_comment (self, value);
#line 3041 "Media.c"
}

static void
noise_media_real_set_comment (NoiseMedia* base,
                              const gchar* value)
{
	NoiseMedia* self;
#line 73 "../core/Media.vala"
	self = base;
#line 73 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_comment (base)) != 0) {
#line 3053 "Media.c"
		gchar* _tmp0_;
#line 73 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 73 "../core/Media.vala"
		_g_free0 (self->priv->_comment);
#line 73 "../core/Media.vala"
		self->priv->_comment = _tmp0_;
#line 73 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_COMMENT_PROPERTY]);
#line 3063 "Media.c"
	}
}

const gchar*
noise_media_get_lyrics (NoiseMedia* self)
{
#line 74 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 74 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_lyrics (self);
#line 3074 "Media.c"
}

static const gchar*
noise_media_real_get_lyrics (NoiseMedia* base)
{
	const gchar* result;
	NoiseMedia* self;
	const gchar* _tmp0_;
#line 74 "../core/Media.vala"
	self = base;
#line 74 "../core/Media.vala"
	_tmp0_ = self->priv->_lyrics;
#line 74 "../core/Media.vala"
	result = _tmp0_;
#line 74 "../core/Media.vala"
	return result;
#line 3091 "Media.c"
}

void
noise_media_set_lyrics (NoiseMedia* self,
                        const gchar* value)
{
#line 74 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 74 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_lyrics (self, value);
#line 3102 "Media.c"
}

static void
noise_media_real_set_lyrics (NoiseMedia* base,
                             const gchar* value)
{
	NoiseMedia* self;
#line 74 "../core/Media.vala"
	self = base;
#line 74 "../core/Media.vala"
	if (g_strcmp0 (value, noise_media_real_get_lyrics (base)) != 0) {
#line 3114 "Media.c"
		gchar* _tmp0_;
#line 74 "../core/Media.vala"
		_tmp0_ = g_strdup (value);
#line 74 "../core/Media.vala"
		_g_free0 (self->priv->_lyrics);
#line 74 "../core/Media.vala"
		self->priv->_lyrics = _tmp0_;
#line 74 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LYRICS_PROPERTY]);
#line 3124 "Media.c"
	}
}

guint
noise_media_get_year (NoiseMedia* self)
{
#line 75 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 75 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_year (self);
#line 3135 "Media.c"
}

static guint
noise_media_real_get_year (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 75 "../core/Media.vala"
	self = base;
#line 75 "../core/Media.vala"
	result = self->priv->_year;
#line 75 "../core/Media.vala"
	return result;
#line 3149 "Media.c"
}

void
noise_media_set_year (NoiseMedia* self,
                      guint value)
{
#line 75 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 75 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_year (self, value);
#line 3160 "Media.c"
}

static void
noise_media_real_set_year (NoiseMedia* base,
                           guint value)
{
	NoiseMedia* self;
#line 75 "../core/Media.vala"
	self = base;
#line 75 "../core/Media.vala"
	if (noise_media_real_get_year (base) != value) {
#line 75 "../core/Media.vala"
		self->priv->_year = value;
#line 75 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_YEAR_PROPERTY]);
#line 3176 "Media.c"
	}
}

guint
noise_media_get_bitrate (NoiseMedia* self)
{
#line 76 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 76 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_bitrate (self);
#line 3187 "Media.c"
}

static guint
noise_media_real_get_bitrate (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 76 "../core/Media.vala"
	self = base;
#line 76 "../core/Media.vala"
	result = self->priv->_bitrate;
#line 76 "../core/Media.vala"
	return result;
#line 3201 "Media.c"
}

void
noise_media_set_bitrate (NoiseMedia* self,
                         guint value)
{
#line 76 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 76 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_bitrate (self, value);
#line 3212 "Media.c"
}

static void
noise_media_real_set_bitrate (NoiseMedia* base,
                              guint value)
{
	NoiseMedia* self;
#line 76 "../core/Media.vala"
	self = base;
#line 76 "../core/Media.vala"
	if (noise_media_real_get_bitrate (base) != value) {
#line 76 "../core/Media.vala"
		self->priv->_bitrate = value;
#line 76 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_BITRATE_PROPERTY]);
#line 3228 "Media.c"
	}
}

guint
noise_media_get_bpm (NoiseMedia* self)
{
#line 77 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 77 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_bpm (self);
#line 3239 "Media.c"
}

static guint
noise_media_real_get_bpm (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 77 "../core/Media.vala"
	self = base;
#line 77 "../core/Media.vala"
	result = self->priv->_bpm;
#line 77 "../core/Media.vala"
	return result;
#line 3253 "Media.c"
}

void
noise_media_set_bpm (NoiseMedia* self,
                     guint value)
{
#line 77 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 77 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_bpm (self, value);
#line 3264 "Media.c"
}

static void
noise_media_real_set_bpm (NoiseMedia* base,
                          guint value)
{
	NoiseMedia* self;
#line 77 "../core/Media.vala"
	self = base;
#line 77 "../core/Media.vala"
	if (noise_media_real_get_bpm (base) != value) {
#line 77 "../core/Media.vala"
		self->priv->_bpm = value;
#line 77 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_BPM_PROPERTY]);
#line 3280 "Media.c"
	}
}

guint
noise_media_get_samplerate (NoiseMedia* self)
{
#line 78 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 78 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_samplerate (self);
#line 3291 "Media.c"
}

static guint
noise_media_real_get_samplerate (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 78 "../core/Media.vala"
	self = base;
#line 78 "../core/Media.vala"
	result = self->priv->_samplerate;
#line 78 "../core/Media.vala"
	return result;
#line 3305 "Media.c"
}

void
noise_media_set_samplerate (NoiseMedia* self,
                            guint value)
{
#line 78 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 78 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_samplerate (self, value);
#line 3316 "Media.c"
}

static void
noise_media_real_set_samplerate (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
#line 78 "../core/Media.vala"
	self = base;
#line 78 "../core/Media.vala"
	if (noise_media_real_get_samplerate (base) != value) {
#line 78 "../core/Media.vala"
		self->priv->_samplerate = value;
#line 78 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SAMPLERATE_PROPERTY]);
#line 3332 "Media.c"
	}
}

guint
noise_media_get_length (NoiseMedia* self)
{
#line 80 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 80 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_length (self);
#line 3343 "Media.c"
}

static guint
noise_media_real_get_length (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 80 "../core/Media.vala"
	self = base;
#line 80 "../core/Media.vala"
	result = self->priv->_length;
#line 80 "../core/Media.vala"
	return result;
#line 3357 "Media.c"
}

void
noise_media_set_length (NoiseMedia* self,
                        guint value)
{
#line 80 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 80 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_length (self, value);
#line 3368 "Media.c"
}

static void
noise_media_real_set_length (NoiseMedia* base,
                             guint value)
{
	NoiseMedia* self;
#line 80 "../core/Media.vala"
	self = base;
#line 80 "../core/Media.vala"
	if (noise_media_real_get_length (base) != value) {
#line 80 "../core/Media.vala"
		self->priv->_length = value;
#line 80 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LENGTH_PROPERTY]);
#line 3384 "Media.c"
	}
}

guint
noise_media_get_rating (NoiseMedia* self)
{
#line 84 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 84 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_rating (self);
#line 3395 "Media.c"
}

static guint
noise_media_real_get_rating (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 84 "../core/Media.vala"
	self = base;
#line 84 "../core/Media.vala"
	result = self->_rating;
#line 84 "../core/Media.vala"
	return result;
#line 3409 "Media.c"
}

void
noise_media_set_rating (NoiseMedia* self,
                        guint value)
{
#line 85 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 85 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_rating (self, value);
#line 3420 "Media.c"
}

static void
noise_media_real_set_rating (NoiseMedia* base,
                             guint value)
{
	NoiseMedia* self;
#line 85 "../core/Media.vala"
	self = base;
#line 85 "../core/Media.vala"
	self->_rating = CLAMP (value, (guint) 0, (guint) 5);
#line 85 "../core/Media.vala"
	g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_RATING_PROPERTY]);
#line 3434 "Media.c"
}

guint
noise_media_get_play_count (NoiseMedia* self)
{
#line 91 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 91 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_play_count (self);
#line 3444 "Media.c"
}

static guint
noise_media_real_get_play_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 91 "../core/Media.vala"
	self = base;
#line 91 "../core/Media.vala"
	result = self->priv->_play_count;
#line 91 "../core/Media.vala"
	return result;
#line 3458 "Media.c"
}

void
noise_media_set_play_count (NoiseMedia* self,
                            guint value)
{
#line 91 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 91 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_play_count (self, value);
#line 3469 "Media.c"
}

static void
noise_media_real_set_play_count (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
#line 91 "../core/Media.vala"
	self = base;
#line 91 "../core/Media.vala"
	if (noise_media_real_get_play_count (base) != value) {
#line 91 "../core/Media.vala"
		self->priv->_play_count = value;
#line 91 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_PLAY_COUNT_PROPERTY]);
#line 3485 "Media.c"
	}
}

guint
noise_media_get_skip_count (NoiseMedia* self)
{
#line 92 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 92 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_skip_count (self);
#line 3496 "Media.c"
}

static guint
noise_media_real_get_skip_count (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 92 "../core/Media.vala"
	self = base;
#line 92 "../core/Media.vala"
	result = self->priv->_skip_count;
#line 92 "../core/Media.vala"
	return result;
#line 3510 "Media.c"
}

void
noise_media_set_skip_count (NoiseMedia* self,
                            guint value)
{
#line 92 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 92 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_skip_count (self, value);
#line 3521 "Media.c"
}

static void
noise_media_real_set_skip_count (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
#line 92 "../core/Media.vala"
	self = base;
#line 92 "../core/Media.vala"
	if (noise_media_real_get_skip_count (base) != value) {
#line 92 "../core/Media.vala"
		self->priv->_skip_count = value;
#line 92 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SKIP_COUNT_PROPERTY]);
#line 3537 "Media.c"
	}
}

guint
noise_media_get_date_added (NoiseMedia* self)
{
#line 93 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 93 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_date_added (self);
#line 3548 "Media.c"
}

static guint
noise_media_real_get_date_added (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 93 "../core/Media.vala"
	self = base;
#line 93 "../core/Media.vala"
	result = self->priv->_date_added;
#line 93 "../core/Media.vala"
	return result;
#line 3562 "Media.c"
}

void
noise_media_set_date_added (NoiseMedia* self,
                            guint value)
{
#line 93 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 93 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_date_added (self, value);
#line 3573 "Media.c"
}

static void
noise_media_real_set_date_added (NoiseMedia* base,
                                 guint value)
{
	NoiseMedia* self;
#line 93 "../core/Media.vala"
	self = base;
#line 93 "../core/Media.vala"
	if (noise_media_real_get_date_added (base) != value) {
#line 93 "../core/Media.vala"
		self->priv->_date_added = value;
#line 93 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_DATE_ADDED_PROPERTY]);
#line 3589 "Media.c"
	}
}

guint
noise_media_get_last_played (NoiseMedia* self)
{
#line 94 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 94 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_last_played (self);
#line 3600 "Media.c"
}

static guint
noise_media_real_get_last_played (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 94 "../core/Media.vala"
	self = base;
#line 94 "../core/Media.vala"
	result = self->priv->_last_played;
#line 94 "../core/Media.vala"
	return result;
#line 3614 "Media.c"
}

void
noise_media_set_last_played (NoiseMedia* self,
                             guint value)
{
#line 94 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 94 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_last_played (self, value);
#line 3625 "Media.c"
}

static void
noise_media_real_set_last_played (NoiseMedia* base,
                                  guint value)
{
	NoiseMedia* self;
#line 94 "../core/Media.vala"
	self = base;
#line 94 "../core/Media.vala"
	if (noise_media_real_get_last_played (base) != value) {
#line 94 "../core/Media.vala"
		self->priv->_last_played = value;
#line 94 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LAST_PLAYED_PROPERTY]);
#line 3641 "Media.c"
	}
}

guint
noise_media_get_last_modified (NoiseMedia* self)
{
#line 95 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 95 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_last_modified (self);
#line 3652 "Media.c"
}

static guint
noise_media_real_get_last_modified (NoiseMedia* base)
{
	guint result;
	NoiseMedia* self;
#line 95 "../core/Media.vala"
	self = base;
#line 95 "../core/Media.vala"
	result = self->priv->_last_modified;
#line 95 "../core/Media.vala"
	return result;
#line 3666 "Media.c"
}

void
noise_media_set_last_modified (NoiseMedia* self,
                               guint value)
{
#line 95 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 95 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_last_modified (self, value);
#line 3677 "Media.c"
}

static void
noise_media_real_set_last_modified (NoiseMedia* base,
                                    guint value)
{
	NoiseMedia* self;
#line 95 "../core/Media.vala"
	self = base;
#line 95 "../core/Media.vala"
	if (noise_media_real_get_last_modified (base) != value) {
#line 95 "../core/Media.vala"
		self->priv->_last_modified = value;
#line 95 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_LAST_MODIFIED_PROPERTY]);
#line 3693 "Media.c"
	}
}

gint
noise_media_get_resume_pos (NoiseMedia* self)
{
#line 97 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 97 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_resume_pos (self);
#line 3704 "Media.c"
}

static gint
noise_media_real_get_resume_pos (NoiseMedia* base)
{
	gint result;
	NoiseMedia* self;
#line 97 "../core/Media.vala"
	self = base;
#line 97 "../core/Media.vala"
	result = self->priv->_resume_pos;
#line 97 "../core/Media.vala"
	return result;
#line 3718 "Media.c"
}

void
noise_media_set_resume_pos (NoiseMedia* self,
                            gint value)
{
#line 97 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 97 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_resume_pos (self, value);
#line 3729 "Media.c"
}

static void
noise_media_real_set_resume_pos (NoiseMedia* base,
                                 gint value)
{
	NoiseMedia* self;
#line 97 "../core/Media.vala"
	self = base;
#line 97 "../core/Media.vala"
	if (noise_media_real_get_resume_pos (base) != value) {
#line 97 "../core/Media.vala"
		self->priv->_resume_pos = value;
#line 97 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_RESUME_POS_PROPERTY]);
#line 3745 "Media.c"
	}
}

gboolean
noise_media_get_show (NoiseMedia* self)
{
#line 98 "../core/Media.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../core/Media.vala"
	return NOISE_MEDIA_GET_CLASS (self)->get_show (self);
#line 3756 "Media.c"
}

static gboolean
noise_media_real_get_show (NoiseMedia* base)
{
	gboolean result;
	NoiseMedia* self;
#line 98 "../core/Media.vala"
	self = base;
#line 98 "../core/Media.vala"
	result = self->priv->_show;
#line 98 "../core/Media.vala"
	return result;
#line 3770 "Media.c"
}

void
noise_media_set_show (NoiseMedia* self,
                      gboolean value)
{
#line 98 "../core/Media.vala"
	g_return_if_fail (self != NULL);
#line 98 "../core/Media.vala"
	NOISE_MEDIA_GET_CLASS (self)->set_show (self, value);
#line 3781 "Media.c"
}

static void
noise_media_real_set_show (NoiseMedia* base,
                           gboolean value)
{
	NoiseMedia* self;
#line 98 "../core/Media.vala"
	self = base;
#line 98 "../core/Media.vala"
	if (noise_media_real_get_show (base) != value) {
#line 98 "../core/Media.vala"
		self->priv->_show = value;
#line 98 "../core/Media.vala"
		g_object_notify_by_pspec ((GObject *) self, noise_media_properties[NOISE_MEDIA_SHOW_PROPERTY]);
#line 3797 "Media.c"
	}
}

static void
noise_media_class_init (NoiseMediaClass * klass,
                        gpointer klass_data)
{
	gchar* _tmp0_;
#line 29 "../core/Media.vala"
	noise_media_parent_class = g_type_class_peek_parent (klass);
#line 29 "../core/Media.vala"
	g_type_class_adjust_private_offset (klass, &NoiseMedia_private_offset);
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_uri = noise_media_real_get_uri;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_uri = noise_media_real_set_uri;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_file_size = noise_media_real_get_file_size;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_file_size = noise_media_real_set_file_size;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_file_exists = noise_media_real_get_file_exists;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_file = noise_media_real_get_file;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_file = noise_media_real_set_file;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_isPreview = noise_media_real_get_isPreview;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_isPreview = noise_media_real_set_isPreview;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_isTemporary = noise_media_real_get_isTemporary;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_isTemporary = noise_media_real_set_isTemporary;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_location_unknown = noise_media_real_get_location_unknown;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_location_unknown = noise_media_real_set_location_unknown;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_has_embedded = noise_media_real_get_has_embedded;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_has_embedded = noise_media_real_set_has_embedded;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_unique_status_image = noise_media_real_get_unique_status_image;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_unique_status_image = noise_media_real_set_unique_status_image;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_showIndicator = noise_media_real_get_showIndicator;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_showIndicator = noise_media_real_set_showIndicator;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_title = noise_media_real_get_title;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_title = noise_media_real_set_title;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_track = noise_media_real_get_track;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_track = noise_media_real_set_track;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_track_count = noise_media_real_get_track_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_track_count = noise_media_real_set_track_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_composer = noise_media_real_get_composer;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_composer = noise_media_real_set_composer;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_artist = noise_media_real_get_artist;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_artist = noise_media_real_set_artist;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_artist = noise_media_real_get_album_artist;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_artist = noise_media_real_set_album_artist;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album = noise_media_real_get_album;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album = noise_media_real_set_album;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_number = noise_media_real_get_album_number;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_number = noise_media_real_set_album_number;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_count = noise_media_real_get_album_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_count = noise_media_real_set_album_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_album_info = noise_media_real_get_album_info;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_album_info = noise_media_real_set_album_info;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_grouping = noise_media_real_get_grouping;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_grouping = noise_media_real_set_grouping;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_genre = noise_media_real_get_genre;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_genre = noise_media_real_set_genre;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_comment = noise_media_real_get_comment;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_comment = noise_media_real_set_comment;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_lyrics = noise_media_real_get_lyrics;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_lyrics = noise_media_real_set_lyrics;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_year = noise_media_real_get_year;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_year = noise_media_real_set_year;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_bitrate = noise_media_real_get_bitrate;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_bitrate = noise_media_real_set_bitrate;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_bpm = noise_media_real_get_bpm;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_bpm = noise_media_real_set_bpm;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_samplerate = noise_media_real_get_samplerate;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_samplerate = noise_media_real_set_samplerate;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_length = noise_media_real_get_length;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_length = noise_media_real_set_length;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_rating = noise_media_real_get_rating;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_rating = noise_media_real_set_rating;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_play_count = noise_media_real_get_play_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_play_count = noise_media_real_set_play_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_skip_count = noise_media_real_get_skip_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_skip_count = noise_media_real_set_skip_count;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_date_added = noise_media_real_get_date_added;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_date_added = noise_media_real_set_date_added;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_played = noise_media_real_get_last_played;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_played = noise_media_real_set_last_played;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_last_modified = noise_media_real_get_last_modified;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_last_modified = noise_media_real_set_last_modified;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_resume_pos = noise_media_real_get_resume_pos;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_resume_pos = noise_media_real_set_resume_pos;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->get_show = noise_media_real_get_show;
#line 29 "../core/Media.vala"
	NOISE_MEDIA_CLASS (klass)->set_show = noise_media_real_set_show;
#line 29 "../core/Media.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_noise_media_get_property;
#line 29 "../core/Media.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_noise_media_set_property;
#line 29 "../core/Media.vala"
	G_OBJECT_CLASS (klass)->finalize = noise_media_finalize;
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ROWID_PROPERTY, noise_media_properties[NOISE_MEDIA_ROWID_PROPERTY] = g_param_spec_int64 ("rowid", "rowid", "rowid", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_URI_PROPERTY, noise_media_properties[NOISE_MEDIA_URI_PROPERTY] = g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_SIZE_PROPERTY, noise_media_properties[NOISE_MEDIA_FILE_SIZE_PROPERTY] = g_param_spec_uint64 ("file-size", "file-size", "file-size", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_EXISTS_PROPERTY, noise_media_properties[NOISE_MEDIA_FILE_EXISTS_PROPERTY] = g_param_spec_boolean ("file-exists", "file-exists", "file-exists", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_FILE_PROPERTY, noise_media_properties[NOISE_MEDIA_FILE_PROPERTY] = g_param_spec_object ("file", "file", "file", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_IS_PREVIEW_PROPERTY, noise_media_properties[NOISE_MEDIA_IS_PREVIEW_PROPERTY] = g_param_spec_boolean ("isPreview", "isPreview", "isPreview", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_IS_TEMPORARY_PROPERTY, noise_media_properties[NOISE_MEDIA_IS_TEMPORARY_PROPERTY] = g_param_spec_boolean ("isTemporary", "isTemporary", "isTemporary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY, noise_media_properties[NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY] = g_param_spec_boolean ("location-unknown", "location-unknown", "location-unknown", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_HAS_EMBEDDED_PROPERTY, noise_media_properties[NOISE_MEDIA_HAS_EMBEDDED_PROPERTY] = g_param_spec_boolean ("has-embedded", "has-embedded", "has-embedded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY, noise_media_properties[NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY] = g_param_spec_object ("unique-status-image", "unique-status-image", "unique-status-image", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SHOW_INDICATOR_PROPERTY, noise_media_properties[NOISE_MEDIA_SHOW_INDICATOR_PROPERTY] = g_param_spec_boolean ("showIndicator", "showIndicator", "showIndicator", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3984 "Media.c"
	/**
	     * Metadata Fields
	     */
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TITLE_PROPERTY, noise_media_properties[NOISE_MEDIA_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TRACK_PROPERTY, noise_media_properties[NOISE_MEDIA_TRACK_PROPERTY] = g_param_spec_uint ("track", "track", "track", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_TRACK_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_TRACK_COUNT_PROPERTY] = g_param_spec_uint ("track-count", "track-count", "track-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_COMPOSER_PROPERTY, noise_media_properties[NOISE_MEDIA_COMPOSER_PROPERTY] = g_param_spec_string ("composer", "composer", "composer", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ARTIST_PROPERTY, noise_media_properties[NOISE_MEDIA_ARTIST_PROPERTY] = g_param_spec_string ("artist", "artist", "artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_ARTIST_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_ARTIST_PROPERTY] = g_param_spec_string ("album-artist", "album-artist", "album-artist", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_PROPERTY] = g_param_spec_string ("album", "album", "album", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_NUMBER_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_NUMBER_PROPERTY] = g_param_spec_uint ("album-number", "album-number", "album-number", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_COUNT_PROPERTY] = g_param_spec_uint ("album-count", "album-count", "album-count", 0, G_MAXUINT, (guint) 1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_ALBUM_INFO_PROPERTY, noise_media_properties[NOISE_MEDIA_ALBUM_INFO_PROPERTY] = g_param_spec_object ("album-info", "album-info", "album-info", NOISE_TYPE_ALBUM, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_GROUPING_PROPERTY, noise_media_properties[NOISE_MEDIA_GROUPING_PROPERTY] = g_param_spec_string ("grouping", "grouping", "grouping", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_GENRE_PROPERTY, noise_media_properties[NOISE_MEDIA_GENRE_PROPERTY] = g_param_spec_string ("genre", "genre", "genre", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_COMMENT_PROPERTY, noise_media_properties[NOISE_MEDIA_COMMENT_PROPERTY] = g_param_spec_string ("comment", "comment", "comment", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LYRICS_PROPERTY, noise_media_properties[NOISE_MEDIA_LYRICS_PROPERTY] = g_param_spec_string ("lyrics", "lyrics", "lyrics", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_YEAR_PROPERTY, noise_media_properties[NOISE_MEDIA_YEAR_PROPERTY] = g_param_spec_uint ("year", "year", "year", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_BITRATE_PROPERTY, noise_media_properties[NOISE_MEDIA_BITRATE_PROPERTY] = g_param_spec_uint ("bitrate", "bitrate", "bitrate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_BPM_PROPERTY, noise_media_properties[NOISE_MEDIA_BPM_PROPERTY] = g_param_spec_uint ("bpm", "bpm", "bpm", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SAMPLERATE_PROPERTY, noise_media_properties[NOISE_MEDIA_SAMPLERATE_PROPERTY] = g_param_spec_uint ("samplerate", "samplerate", "samplerate", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LENGTH_PROPERTY, noise_media_properties[NOISE_MEDIA_LENGTH_PROPERTY] = g_param_spec_uint ("length", "length", "length", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_RATING_PROPERTY, noise_media_properties[NOISE_MEDIA_RATING_PROPERTY] = g_param_spec_uint ("rating", "rating", "rating", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4028 "Media.c"
	/**
	     * Internal stats
	     */
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_PLAY_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_PLAY_COUNT_PROPERTY] = g_param_spec_uint ("play-count", "play-count", "play-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SKIP_COUNT_PROPERTY, noise_media_properties[NOISE_MEDIA_SKIP_COUNT_PROPERTY] = g_param_spec_uint ("skip-count", "skip-count", "skip-count", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_DATE_ADDED_PROPERTY, noise_media_properties[NOISE_MEDIA_DATE_ADDED_PROPERTY] = g_param_spec_uint ("date-added", "date-added", "date-added", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LAST_PLAYED_PROPERTY, noise_media_properties[NOISE_MEDIA_LAST_PLAYED_PROPERTY] = g_param_spec_uint ("last-played", "last-played", "last-played", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_LAST_MODIFIED_PROPERTY, noise_media_properties[NOISE_MEDIA_LAST_MODIFIED_PROPERTY] = g_param_spec_uint ("last-modified", "last-modified", "last-modified", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_RESUME_POS_PROPERTY, noise_media_properties[NOISE_MEDIA_RESUME_POS_PROPERTY] = g_param_spec_int ("resume-pos", "resume-pos", "resume-pos", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../core/Media.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), NOISE_MEDIA_SHOW_PROPERTY, noise_media_properties[NOISE_MEDIA_SHOW_PROPERTY] = g_param_spec_boolean ("show", "show", "show", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 32 "../core/Media.vala"
	_tmp0_ = g_strdup (_ ("Unknown"));
#line 32 "../core/Media.vala"
	noise_media_UNKNOWN = _tmp0_;
#line 4050 "Media.c"
}

static void
noise_media_instance_init (NoiseMedia * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 29 "../core/Media.vala"
	self->priv = noise_media_get_instance_private (self);
#line 41 "../core/Media.vala"
	self->priv->_file_size = (guint64) 0;
#line 46 "../core/Media.vala"
	self->priv->_isPreview = FALSE;
#line 47 "../core/Media.vala"
	self->priv->_isTemporary = FALSE;
#line 50 "../core/Media.vala"
	self->priv->_location_unknown = FALSE;
#line 51 "../core/Media.vala"
	self->priv->_has_embedded = FALSE;
#line 56 "../core/Media.vala"
	self->priv->_showIndicator = FALSE;
#line 61 "../core/Media.vala"
	_tmp0_ = g_strdup ("");
#line 61 "../core/Media.vala"
	self->priv->_title = _tmp0_;
#line 62 "../core/Media.vala"
	self->priv->_track = (guint) 0;
#line 63 "../core/Media.vala"
	self->priv->_track_count = (guint) 0;
#line 64 "../core/Media.vala"
	_tmp1_ = g_strdup ("");
#line 64 "../core/Media.vala"
	self->priv->_composer = _tmp1_;
#line 65 "../core/Media.vala"
	_tmp2_ = g_strdup ("");
#line 65 "../core/Media.vala"
	self->priv->_artist = _tmp2_;
#line 66 "../core/Media.vala"
	_tmp3_ = g_strdup ("");
#line 66 "../core/Media.vala"
	self->priv->_album_artist = _tmp3_;
#line 67 "../core/Media.vala"
	_tmp4_ = g_strdup ("");
#line 67 "../core/Media.vala"
	self->priv->_album = _tmp4_;
#line 68 "../core/Media.vala"
	self->priv->_album_number = (guint) 1;
#line 69 "../core/Media.vala"
	self->priv->_album_count = (guint) 1;
#line 70 "../core/Media.vala"
	self->priv->_album_info = NULL;
#line 71 "../core/Media.vala"
	_tmp5_ = g_strdup ("");
#line 71 "../core/Media.vala"
	self->priv->_grouping = _tmp5_;
#line 72 "../core/Media.vala"
	_tmp6_ = g_strdup ("");
#line 72 "../core/Media.vala"
	self->priv->_genre = _tmp6_;
#line 73 "../core/Media.vala"
	_tmp7_ = g_strdup ("");
#line 73 "../core/Media.vala"
	self->priv->_comment = _tmp7_;
#line 74 "../core/Media.vala"
	_tmp8_ = g_strdup ("");
#line 74 "../core/Media.vala"
	self->priv->_lyrics = _tmp8_;
#line 75 "../core/Media.vala"
	self->priv->_year = (guint) 0;
#line 76 "../core/Media.vala"
	self->priv->_bitrate = (guint) 0;
#line 77 "../core/Media.vala"
	self->priv->_bpm = (guint) 0;
#line 78 "../core/Media.vala"
	self->priv->_samplerate = (guint) 0;
#line 80 "../core/Media.vala"
	self->priv->_length = (guint) 0;
#line 91 "../core/Media.vala"
	self->priv->_play_count = (guint) 0;
#line 92 "../core/Media.vala"
	self->priv->_skip_count = (guint) 0;
#line 93 "../core/Media.vala"
	self->priv->_date_added = (guint) 0;
#line 94 "../core/Media.vala"
	self->priv->_last_played = (guint) 0;
#line 95 "../core/Media.vala"
	self->priv->_last_modified = (guint) 0;
#line 97 "../core/Media.vala"
	self->priv->_resume_pos = 0;
#line 98 "../core/Media.vala"
	self->priv->_show = TRUE;
#line 4150 "Media.c"
}

static void
noise_media_finalize (GObject * obj)
{
	NoiseMedia * self;
#line 29 "../core/Media.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, NOISE_TYPE_MEDIA, NoiseMedia);
#line 44 "../core/Media.vala"
	_g_object_unref0 (self->priv->_file);
#line 55 "../core/Media.vala"
	_g_object_unref0 (self->priv->_unique_status_image);
#line 61 "../core/Media.vala"
	_g_free0 (self->priv->_title);
#line 64 "../core/Media.vala"
	_g_free0 (self->priv->_composer);
#line 65 "../core/Media.vala"
	_g_free0 (self->priv->_artist);
#line 66 "../core/Media.vala"
	_g_free0 (self->priv->_album_artist);
#line 67 "../core/Media.vala"
	_g_free0 (self->priv->_album);
#line 71 "../core/Media.vala"
	_g_free0 (self->priv->_grouping);
#line 72 "../core/Media.vala"
	_g_free0 (self->priv->_genre);
#line 73 "../core/Media.vala"
	_g_free0 (self->priv->_comment);
#line 74 "../core/Media.vala"
	_g_free0 (self->priv->_lyrics);
#line 29 "../core/Media.vala"
	G_OBJECT_CLASS (noise_media_parent_class)->finalize (obj);
#line 4183 "Media.c"
}

GType
noise_media_get_type (void)
{
	static volatile gsize noise_media_type_id__volatile = 0;
	if (g_once_init_enter (&noise_media_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (NoiseMediaClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) noise_media_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NoiseMedia), 0, (GInstanceInitFunc) noise_media_instance_init, NULL };
		GType noise_media_type_id;
		noise_media_type_id = g_type_register_static (G_TYPE_OBJECT, "NoiseMedia", &g_define_type_info, 0);
		NoiseMedia_private_offset = g_type_add_instance_private (noise_media_type_id, sizeof (NoiseMediaPrivate));
		g_once_init_leave (&noise_media_type_id__volatile, noise_media_type_id);
	}
	return noise_media_type_id__volatile;
}

static void
_vala_noise_media_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	NoiseMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MEDIA, NoiseMedia);
#line 29 "../core/Media.vala"
	switch (property_id) {
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ROWID_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_int64 (value, noise_media_get_rowid (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_URI_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_take_string (value, noise_media_get_uri (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_FILE_SIZE_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint64 (value, noise_media_get_file_size (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_FILE_EXISTS_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_boolean (value, noise_media_get_file_exists (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_FILE_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_object (value, noise_media_get_file (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_IS_PREVIEW_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_boolean (value, noise_media_get_isPreview (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_IS_TEMPORARY_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_boolean (value, noise_media_get_isTemporary (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_boolean (value, noise_media_get_location_unknown (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_HAS_EMBEDDED_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_boolean (value, noise_media_get_has_embedded (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_object (value, noise_media_get_unique_status_image (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SHOW_INDICATOR_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_boolean (value, noise_media_get_showIndicator (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_TITLE_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_title (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_TRACK_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_track (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_TRACK_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_track_count (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_COMPOSER_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_composer (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ARTIST_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_artist (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_album_artist (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_album (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_album_number (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_album_count (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_INFO_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_object (value, noise_media_get_album_info (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_GROUPING_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_grouping (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_GENRE_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_genre (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_COMMENT_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_comment (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LYRICS_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_string (value, noise_media_get_lyrics (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_YEAR_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_year (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_BITRATE_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_bitrate (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_BPM_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_bpm (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SAMPLERATE_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_samplerate (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LENGTH_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_length (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_RATING_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_rating (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_PLAY_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_play_count (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SKIP_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_skip_count (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_DATE_ADDED_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_date_added (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LAST_PLAYED_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_last_played (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LAST_MODIFIED_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_uint (value, noise_media_get_last_modified (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_RESUME_POS_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_int (value, noise_media_get_resume_pos (self));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SHOW_PROPERTY:
#line 29 "../core/Media.vala"
		g_value_set_boolean (value, noise_media_get_show (self));
#line 29 "../core/Media.vala"
		break;
#line 4438 "Media.c"
		default:
#line 29 "../core/Media.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../core/Media.vala"
		break;
#line 4444 "Media.c"
	}
}

static void
_vala_noise_media_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	NoiseMedia * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, NOISE_TYPE_MEDIA, NoiseMedia);
#line 29 "../core/Media.vala"
	switch (property_id) {
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ROWID_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_rowid (self, g_value_get_int64 (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_URI_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_uri (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_FILE_SIZE_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_file_size (self, g_value_get_uint64 (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_FILE_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_file (self, g_value_get_object (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_IS_PREVIEW_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_isPreview (self, g_value_get_boolean (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_IS_TEMPORARY_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_isTemporary (self, g_value_get_boolean (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LOCATION_UNKNOWN_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_location_unknown (self, g_value_get_boolean (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_HAS_EMBEDDED_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_has_embedded (self, g_value_get_boolean (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_UNIQUE_STATUS_IMAGE_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_unique_status_image (self, g_value_get_object (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SHOW_INDICATOR_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_showIndicator (self, g_value_get_boolean (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_TITLE_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_title (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_TRACK_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_track (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_TRACK_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_track_count (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_COMPOSER_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_composer (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ARTIST_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_artist (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_ARTIST_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_album_artist (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_album (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_NUMBER_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_album_number (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_album_count (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_ALBUM_INFO_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_album_info (self, g_value_get_object (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_GROUPING_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_grouping (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_GENRE_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_genre (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_COMMENT_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_comment (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LYRICS_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_lyrics (self, g_value_get_string (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_YEAR_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_year (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_BITRATE_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_bitrate (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_BPM_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_bpm (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SAMPLERATE_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_samplerate (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LENGTH_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_length (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_RATING_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_rating (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_PLAY_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_play_count (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SKIP_COUNT_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_skip_count (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_DATE_ADDED_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_date_added (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LAST_PLAYED_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_last_played (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_LAST_MODIFIED_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_last_modified (self, g_value_get_uint (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_RESUME_POS_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_resume_pos (self, g_value_get_int (value));
#line 29 "../core/Media.vala"
		break;
#line 29 "../core/Media.vala"
		case NOISE_MEDIA_SHOW_PROPERTY:
#line 29 "../core/Media.vala"
		noise_media_set_show (self, g_value_get_boolean (value));
#line 29 "../core/Media.vala"
		break;
#line 4680 "Media.c"
		default:
#line 29 "../core/Media.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../core/Media.vala"
		break;
#line 4686 "Media.c"
	}
}

