/* String.c generated by valac 0.44.0, the Vala compiler
 * generated from String.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2012-2018 elementary LLC. (https://elementary.io)
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The Noise authors hereby grant permission for non-GPL compatible
 * GStreamer plugins to be used and distributed together with GStreamer
 * and Noise. This permission is above and beyond the permissions granted
 * by the GPL license by which Noise is covered. If you modify this code
 * you may extend this exception to your version of the code, but you are not
 * obligated to do so. If you do not wish to do so, delete this exception
 * statement from your version.
 *
 * Authored by: Victor Eduardo <victoreduardm@gmail.com>
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

gboolean noise_string_is_empty (const gchar* text,
                                gboolean check_white_space);
gboolean noise_string_is_white_space (const gchar* text);
gint noise_string_compare (const gchar* a,
                           const gchar* b);
gchar* noise_string_canonicalize_for_search (const gchar* str);
gunichar noise_string_strip_char (gunichar ch);
gchar* noise_string_to_title_case (const gchar* text);
gchar* noise_string_locale_to_utf8 (const gchar* string_locale);
void noise_string_base_search_method (const gchar* search,
                                      guint* parsed_rating,
                                      gchar* * parsed_search_string);
guint* noise_search_get_rating_from_string (const gchar* rating_string);
gchar* noise_search_get_valid_search_string (const gchar* s);
guint64 noise_string_uint_from_string (const gchar* str);

inline gboolean
noise_string_is_empty (const gchar* text,
                       gboolean check_white_space)
{
	gboolean result = FALSE;
#line 32 "../core/Utils/String.vala"
	if (text != NULL) {
#line 64 "String.c"
		gboolean _tmp0_ = FALSE;
#line 33 "../core/Utils/String.vala"
		if (check_white_space) {
#line 33 "../core/Utils/String.vala"
			_tmp0_ = noise_string_is_white_space (text);
#line 70 "String.c"
		} else {
#line 33 "../core/Utils/String.vala"
			_tmp0_ = g_strcmp0 (text, "") == 0;
#line 74 "String.c"
		}
#line 33 "../core/Utils/String.vala"
		result = _tmp0_;
#line 33 "../core/Utils/String.vala"
		return result;
#line 80 "String.c"
	}
#line 34 "../core/Utils/String.vala"
	result = TRUE;
#line 34 "../core/Utils/String.vala"
	return result;
#line 86 "String.c"
}

/**
     * Compares two strings encoded in UTF-8. Used extensively in the views for sorting.
     *
     * It takes into account the current locale's sorting rules and is faster
     * than normal string comparison.
     *
     * /!\ DON'T USE THIS METHOD WITH STRINGS NOT ENCODED IN UTF-8.
     *
     * @param a first string.
     * @param b second string.
     * @return 0 if a == b, a positive number if a > b, or a negative number if a < b.
     */
inline gint
noise_string_compare (const gchar* a,
                      const gchar* b)
{
	gint result = 0;
	gchar* _tmp0_ = NULL;
	gchar* _tmp3_ = NULL;
	GCompareFunc _tmp6_;
#line 51 "../core/Utils/String.vala"
	if (a != NULL) {
#line 111 "String.c"
		gchar* _tmp1_;
#line 51 "../core/Utils/String.vala"
		_tmp1_ = g_utf8_collate_key (a, (gssize) -1);
#line 51 "../core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 51 "../core/Utils/String.vala"
		_tmp0_ = _tmp1_;
#line 119 "String.c"
	} else {
		gchar* _tmp2_;
#line 51 "../core/Utils/String.vala"
		_tmp2_ = g_strdup ((const gchar*) NULL);
#line 51 "../core/Utils/String.vala"
		_g_free0 (_tmp0_);
#line 51 "../core/Utils/String.vala"
		_tmp0_ = _tmp2_;
#line 128 "String.c"
	}
#line 52 "../core/Utils/String.vala"
	if (b != NULL) {
#line 132 "String.c"
		gchar* _tmp4_;
#line 52 "../core/Utils/String.vala"
		_tmp4_ = g_utf8_collate_key (b, (gssize) -1);
#line 52 "../core/Utils/String.vala"
		_g_free0 (_tmp3_);
#line 52 "../core/Utils/String.vala"
		_tmp3_ = _tmp4_;
#line 140 "String.c"
	} else {
		gchar* _tmp5_;
#line 52 "../core/Utils/String.vala"
		_tmp5_ = g_strdup ((const gchar*) NULL);
#line 52 "../core/Utils/String.vala"
		_g_free0 (_tmp3_);
#line 52 "../core/Utils/String.vala"
		_tmp3_ = _tmp5_;
#line 149 "String.c"
	}
#line 51 "../core/Utils/String.vala"
	_tmp6_ = ((GCompareFunc) g_strcmp0);
#line 51 "../core/Utils/String.vala"
	result = _tmp6_ (_tmp0_, _tmp3_);
#line 51 "../core/Utils/String.vala"
	_g_free0 (_tmp3_);
#line 51 "../core/Utils/String.vala"
	_g_free0 (_tmp0_);
#line 51 "../core/Utils/String.vala"
	return result;
#line 161 "String.c"
}

/**
     * Checks whether a string contains only whitespace.
     *
     * @return //true// if text consists enterely of white space.
     */
static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 190 "String.c"
}

inline gboolean
noise_string_is_white_space (const gchar* text)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
#line 60 "../core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 61 "../core/Utils/String.vala"
	_tmp0_ = string_strip (text);
#line 61 "../core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 61 "../core/Utils/String.vala"
	_tmp2_ = strlen (_tmp1_);
#line 61 "../core/Utils/String.vala"
	_tmp3_ = _tmp2_;
#line 61 "../core/Utils/String.vala"
	_tmp4_ = _tmp3_ == 0;
#line 61 "../core/Utils/String.vala"
	_g_free0 (_tmp1_);
#line 61 "../core/Utils/String.vala"
	result = _tmp4_;
#line 61 "../core/Utils/String.vala"
	return result;
#line 220 "String.c"
}

/**
     * Removes irrelevant and meaningless characters from a string. Useful for search operations.
     * (Taken from gnome-contacts' contacts-utils.vala)
     */
static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 240 "String.c"
		gchar* _tmp0_;
#line 1202 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 252 "String.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 256 "String.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 264 "String.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 268 "String.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 274 "String.c"
	}
}

inline gchar*
noise_string_canonicalize_for_search (const gchar* str)
{
	gchar* result = NULL;
	gunichar* buf = NULL;
	gunichar* _tmp0_;
	gint buf_length1;
	gint _buf_size_;
	GString* res = NULL;
	GString* _tmp1_;
	gunichar c = 0U;
	GString* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
#line 68 "../core/Utils/String.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 69 "../core/Utils/String.vala"
	_tmp0_ = g_new0 (gunichar, G_UNICHAR_MAX_DECOMPOSITION_LENGTH);
#line 69 "../core/Utils/String.vala"
	buf = _tmp0_;
#line 69 "../core/Utils/String.vala"
	buf_length1 = G_UNICHAR_MAX_DECOMPOSITION_LENGTH;
#line 69 "../core/Utils/String.vala"
	_buf_size_ = buf_length1;
#line 70 "../core/Utils/String.vala"
	_tmp1_ = g_string_new ("");
#line 70 "../core/Utils/String.vala"
	res = _tmp1_;
#line 306 "String.c"
	{
		gint i = 0;
#line 74 "../core/Utils/String.vala"
		i = 0;
#line 311 "String.c"
		{
			gboolean _tmp2_ = FALSE;
#line 74 "../core/Utils/String.vala"
			_tmp2_ = TRUE;
#line 74 "../core/Utils/String.vala"
			while (TRUE) {
#line 318 "String.c"
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gunichar sc = 0U;
#line 74 "../core/Utils/String.vala"
				if (!_tmp2_) {
#line 324 "String.c"
				}
#line 74 "../core/Utils/String.vala"
				_tmp2_ = FALSE;
#line 74 "../core/Utils/String.vala"
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
#line 74 "../core/Utils/String.vala"
				c = _tmp3_;
#line 74 "../core/Utils/String.vala"
				if (!_tmp4_) {
#line 74 "../core/Utils/String.vala"
					break;
#line 336 "String.c"
				}
#line 75 "../core/Utils/String.vala"
				sc = noise_string_strip_char (c);
#line 77 "../core/Utils/String.vala"
				if (sc != ((gunichar) 0)) {
#line 342 "String.c"
					gsize size = 0UL;
					gunichar* _tmp5_;
					gint _tmp5__length1;
#line 78 "../core/Utils/String.vala"
					_tmp5_ = buf;
#line 78 "../core/Utils/String.vala"
					_tmp5__length1 = buf_length1;
#line 78 "../core/Utils/String.vala"
					size = g_unichar_fully_decompose (sc, FALSE, _tmp5_, (gint) _tmp5__length1);
#line 80 "../core/Utils/String.vala"
					if (size > ((gsize) 0)) {
#line 354 "String.c"
						GString* _tmp6_;
						gunichar* _tmp7_;
						gint _tmp7__length1;
						gunichar _tmp8_;
#line 81 "../core/Utils/String.vala"
						_tmp6_ = res;
#line 81 "../core/Utils/String.vala"
						_tmp7_ = buf;
#line 81 "../core/Utils/String.vala"
						_tmp7__length1 = buf_length1;
#line 81 "../core/Utils/String.vala"
						_tmp8_ = _tmp7_[0];
#line 81 "../core/Utils/String.vala"
						g_string_append_unichar (_tmp6_, _tmp8_);
#line 369 "String.c"
					}
				}
			}
		}
	}
#line 85 "../core/Utils/String.vala"
	_tmp9_ = res;
#line 85 "../core/Utils/String.vala"
	_tmp10_ = _tmp9_->str;
#line 85 "../core/Utils/String.vala"
	_tmp11_ = g_strdup (_tmp10_);
#line 85 "../core/Utils/String.vala"
	result = _tmp11_;
#line 85 "../core/Utils/String.vala"
	_g_string_free0 (res);
#line 85 "../core/Utils/String.vala"
	buf = (g_free (buf), NULL);
#line 85 "../core/Utils/String.vala"
	return result;
#line 389 "String.c"
}

inline gunichar
noise_string_strip_char (gunichar ch)
{
	gunichar result = 0U;
#line 89 "../core/Utils/String.vala"
	switch (g_unichar_type (ch)) {
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_CONTROL:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_FORMAT:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_UNASSIGNED:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_NON_SPACING_MARK:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_COMBINING_MARK:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_ENCLOSING_MARK:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_LINE_SEPARATOR:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_SPACE_SEPARATOR:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_PARAGRAPH_SEPARATOR:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_DASH_PUNCTUATION:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_OPEN_PUNCTUATION:
#line 89 "../core/Utils/String.vala"
		case G_UNICODE_OTHER_PUNCTUATION:
#line 422 "String.c"
		{
#line 102 "../core/Utils/String.vala"
			result = (gunichar) 0;
#line 102 "../core/Utils/String.vala"
			return result;
#line 428 "String.c"
		}
		default:
		{
#line 104 "../core/Utils/String.vala"
			result = g_unichar_tolower (ch);
#line 104 "../core/Utils/String.vala"
			return result;
#line 436 "String.c"
		}
	}
}

/**
     * Capitalizes the initial letters of a UTF-8 string (Title Case).
     *
     * The implementation is guaranteed to be efficient.
     *
     * For example:
     * "This is an input string" => "This Is An Input String"
     * "example string/text"     => "Example String/Text"
     */
inline gchar*
noise_string_to_title_case (const gchar* text)
{
	gchar* result = NULL;
	gboolean capitalize_next = FALSE;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gunichar c = 0U;
	GString* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 117 "../core/Utils/String.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 118 "../core/Utils/String.vala"
	capitalize_next = TRUE;
#line 120 "../core/Utils/String.vala"
	_tmp0_ = g_string_new ("");
#line 120 "../core/Utils/String.vala"
	_result_ = _tmp0_;
#line 469 "String.c"
	{
		gint i = 0;
#line 123 "../core/Utils/String.vala"
		i = 0;
#line 474 "String.c"
		{
			gboolean _tmp1_ = FALSE;
#line 123 "../core/Utils/String.vala"
			_tmp1_ = TRUE;
#line 123 "../core/Utils/String.vala"
			while (TRUE) {
#line 481 "String.c"
				gunichar _tmp2_ = 0U;
				gboolean _tmp3_;
#line 123 "../core/Utils/String.vala"
				if (!_tmp1_) {
#line 486 "String.c"
				}
#line 123 "../core/Utils/String.vala"
				_tmp1_ = FALSE;
#line 123 "../core/Utils/String.vala"
				_tmp3_ = string_get_next_char (text, &i, &_tmp2_);
#line 123 "../core/Utils/String.vala"
				c = _tmp2_;
#line 123 "../core/Utils/String.vala"
				if (!_tmp3_) {
#line 123 "../core/Utils/String.vala"
					break;
#line 498 "String.c"
				}
#line 124 "../core/Utils/String.vala"
				if (capitalize_next) {
#line 502 "String.c"
					GString* _tmp4_;
#line 125 "../core/Utils/String.vala"
					_tmp4_ = _result_;
#line 125 "../core/Utils/String.vala"
					g_string_append_unichar (_tmp4_, g_unichar_totitle (c));
#line 126 "../core/Utils/String.vala"
					capitalize_next = FALSE;
#line 510 "String.c"
				} else {
					GString* _tmp5_;
					gboolean _tmp6_ = FALSE;
#line 128 "../core/Utils/String.vala"
					_tmp5_ = _result_;
#line 128 "../core/Utils/String.vala"
					g_string_append_unichar (_tmp5_, g_unichar_tolower (c));
#line 131 "../core/Utils/String.vala"
					if (g_unichar_isspace (c)) {
#line 131 "../core/Utils/String.vala"
						_tmp6_ = TRUE;
#line 522 "String.c"
					} else {
#line 131 "../core/Utils/String.vala"
						_tmp6_ = g_unichar_iscntrl (c);
#line 526 "String.c"
					}
#line 131 "../core/Utils/String.vala"
					capitalize_next = _tmp6_;
#line 530 "String.c"
				}
			}
		}
	}
#line 135 "../core/Utils/String.vala"
	_tmp7_ = _result_;
#line 135 "../core/Utils/String.vala"
	_tmp8_ = _tmp7_->str;
#line 135 "../core/Utils/String.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 135 "../core/Utils/String.vala"
	result = _tmp9_;
#line 135 "../core/Utils/String.vala"
	_g_string_free0 (_result_);
#line 135 "../core/Utils/String.vala"
	return result;
#line 547 "String.c"
}

/**
     * Converts a string encoded in the native operating system encoding to UTF-8.
     *
     * @param string_locale String in locale encoding.
     * @return String encoded in UTF-8, or //null// if the string could not be converted.
     */
gchar*
noise_string_locale_to_utf8 (const gchar* string_locale)
{
	gchar* result = NULL;
	GError* _error_ = NULL;
	gsize bytes_read = 0UL;
	gsize bytes_written = 0UL;
	gchar* string_utf8 = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gsize _tmp2_ = 0UL;
	gsize _tmp3_ = 0UL;
	GError* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError* _tmp6_;
#line 144 "../core/Utils/String.vala"
	g_return_val_if_fail (string_locale != NULL, NULL);
#line 147 "../core/Utils/String.vala"
	_tmp0_ = strlen (string_locale);
#line 147 "../core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 147 "../core/Utils/String.vala"
	_tmp5_ = g_locale_to_utf8 (string_locale, (gssize) _tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
#line 147 "../core/Utils/String.vala"
	bytes_read = _tmp2_;
#line 147 "../core/Utils/String.vala"
	bytes_written = _tmp3_;
#line 147 "../core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 147 "../core/Utils/String.vala"
	_error_ = _tmp4_;
#line 147 "../core/Utils/String.vala"
	string_utf8 = _tmp5_;
#line 151 "../core/Utils/String.vala"
	_tmp6_ = _error_;
#line 151 "../core/Utils/String.vala"
	if (_tmp6_ != NULL) {
#line 152 "../core/Utils/String.vala"
		_g_free0 (string_utf8);
#line 152 "../core/Utils/String.vala"
		string_utf8 = NULL;
#line 597 "String.c"
	}
#line 154 "../core/Utils/String.vala"
	result = string_utf8;
#line 154 "../core/Utils/String.vala"
	_g_error_free0 (_error_);
#line 154 "../core/Utils/String.vala"
	return result;
#line 605 "String.c"
}

/**
     * Base method used for searches. It does a previous parsing on the search string.
     *
     * If the output value of parsed_rating is greater than 0, then the view should
     * only display the media with that rating in the search results, and ignore
     * the value of parsed_search_string.
     *
     * @param search Non-parsed version of the search string.
     * @param parsed_rating location where the parsed rating it stored, or 0 if the
     * string didn't represent a valid rating.
     * @param parsed_search_string location where the canonicalized version of the
     * search string is stored. Should be passed to the methods in Noise.Search.
     */
void
noise_string_base_search_method (const gchar* search,
                                 guint* parsed_rating,
                                 gchar* * parsed_search_string)
{
	guint _vala_parsed_rating = 0U;
	gchar* _vala_parsed_search_string = NULL;
	guint* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	guint* _tmp2_;
	guint* _tmp3_;
	guint* _tmp4_;
	gchar* _tmp6_;
#line 170 "../core/Utils/String.vala"
	g_return_if_fail (search != NULL);
#line 173 "../core/Utils/String.vala"
	_vala_parsed_rating = (guint) 0;
#line 174 "../core/Utils/String.vala"
	_tmp0_ = string_strip (search);
#line 174 "../core/Utils/String.vala"
	_tmp1_ = _tmp0_;
#line 174 "../core/Utils/String.vala"
	_tmp2_ = noise_search_get_rating_from_string (_tmp1_);
#line 174 "../core/Utils/String.vala"
	_tmp3_ = _tmp2_;
#line 174 "../core/Utils/String.vala"
	_g_free0 (_tmp1_);
#line 174 "../core/Utils/String.vala"
	_result_ = _tmp3_;
#line 176 "../core/Utils/String.vala"
	_tmp4_ = _result_;
#line 176 "../core/Utils/String.vala"
	if (_tmp4_ != NULL) {
#line 655 "String.c"
		guint* _tmp5_;
#line 177 "../core/Utils/String.vala"
		_tmp5_ = _result_;
#line 177 "../core/Utils/String.vala"
		_vala_parsed_rating = CLAMP (*_tmp5_, (guint) 1, (guint) 5);
#line 661 "String.c"
	}
#line 180 "../core/Utils/String.vala"
	_tmp6_ = noise_search_get_valid_search_string (search);
#line 180 "../core/Utils/String.vala"
	_g_free0 (_vala_parsed_search_string);
#line 180 "../core/Utils/String.vala"
	_vala_parsed_search_string = _tmp6_;
#line 170 "../core/Utils/String.vala"
	_g_free0 (_result_);
#line 170 "../core/Utils/String.vala"
	if (parsed_rating) {
#line 170 "../core/Utils/String.vala"
		*parsed_rating = _vala_parsed_rating;
#line 675 "String.c"
	}
#line 170 "../core/Utils/String.vala"
	if (parsed_search_string) {
#line 170 "../core/Utils/String.vala"
		*parsed_search_string = _vala_parsed_search_string;
#line 681 "String.c"
	} else {
#line 170 "../core/Utils/String.vala"
		_g_free0 (_vala_parsed_search_string);
#line 685 "String.c"
	}
}

/**
     * A method for extracting integers from strings.
     *
     * The method does its best to extract a number from a string by cleaning up
     * non-numeric characters before parsing the string with uint64.parse(). The
     * purpose of this method is to provide a safe way of extracting numbers
     * from strings without making everything crash when passing a weird localized
     * string that would normally lead uint64.parse, int64.parse or int.parse
     * to a segmentation fault. This happens due to encoding incompatibilities:
     * Remember that the standard C library doesn't know how to deal with variable-
     * length UTF-8 characters!
     *
     * If no number is found in the string, zero is returned.
     *
     * Examples:
     * "a23oe ew2" => 232
     " "32 text"   => 32
     * "ins1 32"   => 132
     * "a word"    => 0
     *
     * @param str string known to contain a valid integer
     * @return Result of parsing the string.
     */
static guint64
uint64_parse (const gchar* str)
{
	guint64 result = 0ULL;
#line 782 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 783 "glib-2.0.vapi"
	result = g_ascii_strtoull (str, NULL, (guint) 0);
#line 783 "glib-2.0.vapi"
	return result;
#line 722 "String.c"
}

inline guint64
noise_string_uint_from_string (const gchar* str)
{
	guint64 result = 0ULL;
#line 208 "../core/Utils/String.vala"
	static const gushort MAX_DIGITS = (gushort) 18;
#line 731 "String.c"
	gushort ndigits = 0U;
	GString* _result_ = NULL;
	GString* _tmp0_;
	gunichar c = 0U;
	guint64 _tmp7_ = 0ULL;
#line 206 "../core/Utils/String.vala"
	g_return_val_if_fail (str != NULL, 0ULL);
#line 209 "../core/Utils/String.vala"
	ndigits = (gushort) 0;
#line 211 "../core/Utils/String.vala"
	_tmp0_ = g_string_new ("");
#line 211 "../core/Utils/String.vala"
	_result_ = _tmp0_;
#line 745 "String.c"
	{
		gint i = 0;
#line 214 "../core/Utils/String.vala"
		i = 0;
#line 750 "String.c"
		{
			gboolean _tmp1_ = FALSE;
#line 214 "../core/Utils/String.vala"
			_tmp1_ = TRUE;
#line 214 "../core/Utils/String.vala"
			while (TRUE) {
#line 757 "String.c"
				gboolean _tmp2_ = FALSE;
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
#line 214 "../core/Utils/String.vala"
				if (!_tmp1_) {
#line 763 "String.c"
				}
#line 214 "../core/Utils/String.vala"
				_tmp1_ = FALSE;
#line 214 "../core/Utils/String.vala"
				_tmp4_ = string_get_next_char (str, &i, &_tmp3_);
#line 214 "../core/Utils/String.vala"
				c = _tmp3_;
#line 214 "../core/Utils/String.vala"
				if (_tmp4_) {
#line 214 "../core/Utils/String.vala"
					_tmp2_ = ndigits < MAX_DIGITS;
#line 775 "String.c"
				} else {
#line 214 "../core/Utils/String.vala"
					_tmp2_ = FALSE;
#line 779 "String.c"
				}
#line 214 "../core/Utils/String.vala"
				if (!_tmp2_) {
#line 214 "../core/Utils/String.vala"
					break;
#line 785 "String.c"
				}
#line 215 "../core/Utils/String.vala"
				if (g_unichar_isdigit (c)) {
#line 789 "String.c"
					GString* _tmp5_;
					gushort _tmp6_;
#line 216 "../core/Utils/String.vala"
					_tmp5_ = _result_;
#line 216 "../core/Utils/String.vala"
					g_string_append_unichar (_tmp5_, c);
#line 217 "../core/Utils/String.vala"
					_tmp6_ = ndigits;
#line 217 "../core/Utils/String.vala"
					ndigits = _tmp6_ + 1;
#line 800 "String.c"
				}
			}
		}
	}
#line 221 "../core/Utils/String.vala"
	if (((gint) ndigits) == 0) {
#line 221 "../core/Utils/String.vala"
		_tmp7_ = (guint64) 0;
#line 809 "String.c"
	} else {
		GString* _tmp8_;
		const gchar* _tmp9_;
#line 221 "../core/Utils/String.vala"
		_tmp8_ = _result_;
#line 221 "../core/Utils/String.vala"
		_tmp9_ = _tmp8_->str;
#line 221 "../core/Utils/String.vala"
		_tmp7_ = uint64_parse (_tmp9_);
#line 819 "String.c"
	}
#line 221 "../core/Utils/String.vala"
	result = _tmp7_;
#line 221 "../core/Utils/String.vala"
	_g_string_free0 (_result_);
#line 221 "../core/Utils/String.vala"
	return result;
#line 827 "String.c"
}

